function createCard(question){

    //get data 
    
    var card = new lib.Card();
    
    //private variables
    var scrollCompliment = true; //Ska comment/compliment kunna verskrida befintligt utrymme och drfr behva scrollas in?
    var textOvershoot; //verskridnings storlek
    //var allowAlternateQuestionComment = false;
    
    //public variabels
    card.question = question;
    
    //public functions
    card.updateScore = updateScore;
    card.alternateQuestionComment = alternateQuestionComment;
    card.allowAlternateQuestionComment = allowAlternateQuestionComment;
    
    //It is easier to design in flash with a centered flash authoring tool reg. point (=origo)
    //save width and height to later be able to set createjs regX & regW (positioning offset) so that it is also easy to position the edges of the flash symbol
    card.w = 380; card.h = 266;//from flash (anvnder jmna tal s att halva blir hel pixel)
    card.stop();

 
    //frame 2 content is accessible without need for gotoAndStop()
    tF = card.front.q_tF;
    
    function allowAlternateQuestionComment(){
	if(scrollCompliment){
	    
	    console.log("add event listner")
	    card.front.addEventListener("click", alternateQuestionComment);
		
      
	}
	
    }
    function alternateQuestionComment(){
	console.log("alternat")
	
	    if(textOvershoot != undefined)//om textOvershoot har sats r det >= 0 (0 r falsy precis som undefined men (0 != undefined) r true)
	    {
		card.front.c_tF.visible = true;
		card.front.uncache();
		//cacha textgrafik fr att skerstlla mjuk scrolling av text
		if(card.front.q_tF.text != "")card.front.q_tF.cacheBounds();
		if(card.front.c_tF.text != "")card.front.c_tF.cacheBounds();
	    
		var newY;
		var oldY = card.front.tFC.y// = 0;//containern
		if(oldY == 0)newY = -textOvershoot;
		else newY = 0;
		createjs.Tween.get(card.front.tFC, {override:true}).to( {y:newY}, 7*Math.abs(newY-oldY) ).call(function(){
		    card.front.cache(-card.w/2,-card.h/2,card.w,card.h);//cacha nu front+text fr att skerstlla mjuk tweening av kort 
		}); 
	    }
	    else {
		card.front.q_tF.text = card.question.q+"\n   "+card.question.c;//obs! tillgget hr mste vara samma som testas med i createCard
		card.front.updateCache();//uppdatera gllande cache rect s att tillggstext syns
	    }
    }

    //var font = "calibri, sans-serif";
    var font = "spirequal_lightregular, sans-serif"
    
	if(card.question.pic != undefined){
       
	    //var bitmap = new createjs.Bitmap(card.question.pic);
	    if(card.question.pic > 0){
		var bitmap = new createjs.Sprite(gameData.pics_spriteSheet);
		bitmap.gotoAndStop(card.question.pic-1);
	    }
	    else
	    {
		
		var bitmap = new createjs.Sprite(gameData.photos_spriteSheet);
		bitmap.scaleX = 330/bitmap.getBounds().width;
		bitmap.scaleY = 160/bitmap.getBounds().height;
		bitmap.gotoAndStop(-card.question.pic-1);
	    }
	    
	    //placera/centrera bild - frutstter att bild r mindre n utrymmet p kort (330x160)
	    //-165 och -110 r kortets mittpunkt
	    bitmap.x = -165; 
	    bitmap.y = -110; 
	}
	
	if(card.question.c == ""){    
	    tF.text = card.question.q;
	    if(card.question.pic != undefined){
		card.front.addChild(bitmap);
	    }
	    else{
		if(tF.text != "")adjustTextSize3(tF, {maxHeight:160, lineHeightFactor:1.1, textAlign:"left", fontSize:40, fontFamily:font});
	    }
	}
        else{
	    if(scrollCompliment){
		var amask = new createjs.Shape();
		amask.graphics.beginFill("#000)").drawRect(-200,-110,400,160);//samma positioner och dimmensioner som ursprungliga tF i flash (fast med marginal i x-led d textflt sjlv begrnsar dr)
		//tF.mask = amask;
		
		//lgg till en extra container fr att kunna rymma ett extra TF
		card.front.tFC = new createjs.Container();
		card.front.tFC.mask = amask;
		card.front.hitArea = amask;
		
		card.front.addChild(card.front.tFC);
		//flytta tF till nya container, positioner behlls eftersom containers position r 0,0
		card.front.tFC.addChild(tF);
		var tF2 = new createjs.Text;
		card.front.c_tF = tF2;
		card.front.tFC.addChild(tF2);
		tF2.x = tF.x;
		
		tF.text = card.question.q;
		if(card.question.pic != undefined){  
		    card.front.tFC.addChild(bitmap);
		    tF.fS = 32;
		    tF.h = bitmap.getBounds().height;
		}
		else{   
		    if(tF.text != "")adjustTextSize3(tF, {maxHeight:160, lineHeightFactor:1.1, lineWidth:330, fontSize:32, fontFamily:font});
		}
		tF2.text = card.question.c;
	
		//tF.fS sattes av adjustTextSize och anger slutlig fontstorlek - skicka den s att komplement text aldrig fr strre fontstorlek n frgan
		adjustTextSize3(tF2,  {maxHeight:130, lineHeightFactor:1.1, lineWidth:330, fontSize:tF.fS, fontFamily:font});
	
		tF2.y = tF.y+tF.h + 10; //h r en property som skapas & stts av adjustTextSize
		tF2.visible = false;
		//skapa overshoot property som anger hur mycket vi mste scrolla/tweena fr att visa hela tF2
		textOvershoot = tF.h+10+tF2.h-155;//155 istllet fr 160 fr att f lite marginal
		if(textOvershoot < 0)textOvershoot = 0;
	
	    }  
	    else{
		
		tF.text = card.question.q+"\n   "+card.question.c;
		adjustTextSize3(tF, {maxHeight:160, lineHeightFactor:1.1, fontSize:32, fontFamily:font});
		tF.text = card.question.q;//visa alla frst nr frgan besvarats
	    }
	}
    

    //cacha text tillsammans med front bg (r redan bitmap) s att vi endast har en bitmap att  rita ut
    card.front.cache(-card.w/2,-card.h/2,card.w,card.h);
    
    
    card.timeBar.cache(0,0,330,11);
    
    
    amask = new createjs.Shape();
    amask.graphics.beginFill("#000)").drawRect(0,0,330,11);
    amask.x = card.timeBar.x; 
    amask.y = card.timeBar.y;
    //mask does not need to be on stage but can be and is then visible even if functioning as a mask
    //as a mask it will always be positioned like it is in the same parent container as the masked object - irrespective if it really is added to stage or not
   card.timeBar.mask = amask;
   
   card.timeBar.set = function(ratio){
	 card.timeBar.mask.scaleX = ratio;
   }
   card.hideTime = function(){
	card.timeBar.visible = false;
	card.scoreUnderlay3.visible = false;
	card.timeScoreTF.visible = false;
   }

    //skapa baloonhelp
    //baloonhelp kommer inte att skapas frrn behov - dvs vid mouse over
    //eftersom skapande med target krver att position fr bubble kan berknas och drmed justeras mste card vara frdigskapad och lagd till displaylist med koordinater 
    
    card.label1.cacheBounds(); card.label1.addHitArea(); //textfield kan frlngas med en massa space fr kad hitarea
    var ts = "You can score in THREE ways.\n\nOrder Score: 0 or 100.\n\nPrecision Score: Between 0 & 100 depending on accuracy.\n\nTime Bonus: Between 0 & 100.\n\nOnly an Order Score of 0 counts as an error!"

    card.label1.addEventListener("mouseover", function(e){
	card.removeChild(card.baloon_1);//s att mousedown p icke-touch screen inte skapar dublett
	card.baloon_1 = createBaloonHelp(ts, {lineWidth:190}, {arrowH:8, arrowDir:"north"},card.label1, undefined, undefined);//vi bifogar target vilket medfr att targets parent kommer att add baloon som child
	card.baloon_1.scaleUp(200);
	
	card.label1.addEventListener("mouseout", function (e){
	    card.removeChild(card.baloon_1)//kollar om child verkligen finns (tidsdande jmfrt med removeChildAt), tar bort och returnerar true eller gr inget och returnerar false. Man kan skicka med flera children (komma separerade)
	    e.remove();//removeEventListener mste specificera funktionen s detta r alternativet fr anonyma funktioner
    	});
    });
    //fr touch
    card.label1.addEventListener("mousedown", function(e){
	card.removeChild(card.baloon_1);//fr skerhets skull (inget error om child redan r borttagen)
	card.baloon_1 = createBaloonHelp(ts, {lineWidth:190}, {arrowH:8, arrowDir:"south"}, card.label1, undefined, undefined);//vi bifogar target vilket medfr att targets parent kommer att add baloon som child
	card.baloon_1.scaleUp(200);
	
	e.stopImmediatePropagation();//annars kommer stage.on("mousedown") direkt att aktiveras
	stage.on("mousedown", function (e){//ett alterantiv r att krva tryck p baloon och d krvs inte stopImmediatePropagation
	    card.removeChild(card.baloon_1)//kollar om child verkligen finns (tidsdande jmfrt med removeChildAt), tar bort och returnerar true eller gr inget och returnerar false. Man kan skicka med flera children (komma separerade)
	    e.remove();//removeEventListener mste specificera funktionen s detta r alternativet fr anonyma funktioner
	});
    });
    



    
//    //ett alternativt stt att skapa en baloonhelp r att skapa en bestndig.
//    //nackdelen r att den inte kan anpassa position till screen border overlap och inte heller till targets ev. dynamiska position 
//    var ts = "Depends on time left & your answer.\n\nE.g., if your answer is worth " +Math.floor(gameData.answerScoreMax/2) +" pts, time bonus can at max be " + Math.floor(gameData.answerScoreMax/2) +" points."
//    card.label2Baloon = createBaloonHelp(ts, {lineWidth:160}, {arrowH:8}); 
//    
//    card.addChild(card.label2Baloon);
//    card.label2Baloon.x = 33; card.label2Baloon.y = 115;
//    card.label2Baloon.visible = false;
//    
//    card.label2.cacheBounds(); card.label2.addHitArea(); 
//    card.label2.addEventListener("mouseover", function(e){
//	card.label2Baloon.scaleUp(200, true);
//    });
//    //stage.on("click", function (e){//fr mobiler (hr stage click men vanligt r ocks att click p sjlva tooltip krvs)
//    card.label2.on("mouseout", function (e){
//	card.label2Baloon.visible = false;
//    });
    
    updateScore();

    //card.answer = question.a//y + 0.5;;
    //if(question.d === undefined)card.desc = question.q
    //else{card.desc = question.d}
    //if(question.p === undefined)card.prec = 0;
    //else{card.prec = question.p}    
    

   function updateScore(orderScore, precisionScore, timeScore){
	
	if (orderScore === undefined)orderScore = ' ';
	if (precisionScore === undefined)precisionScore = ' ';
	if (timeScore === undefined)timeScore = ' ';
	
	card.orderScoreTF.text = ''+orderScore;
	card.orderScoreTF.cacheBounds();
	
	card.precisionScoreTF.text = ''+precisionScore;
	card.precisionScoreTF.cacheBounds();
	
	card.timeScoreTF.text = ''+timeScore;
	card.timeScoreTF.cacheBounds();

   }
    return card;     
}

//anvnds ej - behlls fr att visa hur dom-element kan anvndas
function createCard2(question) {
    
    var front = document.createElement("div");
    var back = document.createElement("div");
    front.innerHTML = question.q;
    
    //front.style.width = "250px";
    //front.style.padding = "15px";
    //front.style.height = "140px"
    //front.style.position = "absolute";
    //front.style.top = "0px";
    //front.style.left = "0px";
    //front.style.borderRadius = "10px";
    //front.style.transformStyle = "preserve-3d";
    //front.style.backgroundColor = "#ffff00"
    
    document.getElementById("gameContainer").appendChild(front);
    document.getElementById("gameContainer").appendChild(back);
    
    //classList funkar ej p htc desire
    //front.classList.add("front");//overridden by manually set in js above 
    //back.classList.add("back");
    front.className = "front";
    back.className = "back";
    
    domcard = {};
    domcard.front = front;
    domcard.back = back;
    domE = new createjs.DOMElement(domcard.front);
    stage.addChild(domE);
    console.log("createcard2 end");
}
