function createTLA(fixedYear/*year with fix position during scaling*/, fixedPosition/*0 for left edge, 0.5 for middle, 1 for right edge*/, fontSheet){
      
 
    var tl = new lib.TimelineArrow();
    
    //pxsp kan undertrffa min_pxsp om skalan underskrider min_pxsp/1000000000
    //mer precist nanmn vore min_pixelspan_between_ticks 
    var min_pxsp = 5;//minsta pixelavstnd mellan tv 'rtalsstreck'/ticks. (Spannet mellan de rtal som skrivs ut r 10 ggr strre.)
    tl.min_pxsp = min_pxsp;

    //om yrps nr bottenvrde (1/12) kan pxsp vertrffa max_pxsp om skalan verskrider max_pxsp/(1/12)
    var max_pxsp = 10*min_pxsp;//alltid 10x eftersom yrsp r en tiopotens 
    tl.max_pxsp = max_pxsp;
   
    var yrsps = [1000000000, 100000000, 10000000, 1000000, 100000, 10000, 1000, 100, 10, 1, 1/12];//bttre namn vore yearspans_between_ticks
    
    //nedan satt min- & maxscale r de vrden som skalan mste hlla sig inom fr att pxsp ska hlla sig mellan sina min- och maxvrde
    tl.minScale = min_pxsp/yrsps[0];
    tl.maxScale = max_pxsp/yrsps[yrsps.length-1];
    //vi kan dock begrnsa dem 
    tl.minScale *= 7;
    tl.maxScale *= 0.2;
    

    tl.fixedYear = fixedYear;
    tl.fixedPosition = fixedPosition;
    tl.scale = 1; //scale = pixels per year - stts av slider och bestmmer yrsp & pxsp i drawtimeline
    var yrsp = 1;//year span, antal r mellan strecken p timeline. beror p skalan och pxsp, antal pixel mellan strecken
    var pxsp = 1;
    tl.callbackFunctionForSet;
    
    /*tl.maskedContainer finns frn brjan*/
    tl.maskedContainer = new createjs.Container();
    
    var amask = new createjs.Shape();
    amask.setBounds(-310,0,630,56);//when using getBounds these values will be used without trying to calculate anything (shape's bound can't be calcultated anyhow)
    amask.graphics.beginFill("#000000").drawRect(amask.getBounds().x,amask.getBounds().y,amask.getBounds().width,amask.getBounds().height);
    
    
    
    tl.addChild(tl.maskedContainer);
    tl.maskedContainer.mask = amask;
    var leftMaskEdge_yr, rightMaskEdge_yr
    	var edge_yr, start_yr;
    
    tl.maskedContainer.hitArea = amask;//om vi satte sjlva tl.s hitArea skulle vi omjliggra interaktiva children som markers och descbubbles!
    //tl.mouseChildren = false;//ondigt nr hitArea r satt
    tl.unmaskedContainer = new createjs.Container();
    tl.addChild(tl.unmaskedContainer);
    
    tl.defEvents = [];//ska innehlla data objekt med properties .a (answer/rtal) .d (descripton/label) .q (frga, text som erstter om d inte har innehll) 
    //tl.newEvents = [];//se som lggs till under nivs spelande, ges annan frg
    tl.visibleEvents = [];//skapas p nytt fr varje utritning
    
    //public functions
    tl.addMarker = addMarker;
    tl.addDescBubble = addDescBubble;
    tl.drawTimeline = drawTimeline;
    tl.getPixel = getPixel;
    tl.getPixelExact = getPixelExact;
    tl.getYear = getYear;
    tl.getYearAtMaskEnd = getYearAtMaskEnd;
    tl.getPosition = getPosition;
    tl.getPosition_px = getPosition_px;
    tl.setTimeline = setTimeline;
   
    var smx_atDragStart, smy_atDragStart, prev_drag_x, prev_drag_y, accu_x, accu_y;//acc ackumulerad drag rrelse (+ och - ska inte ta ut varandra) som avgr om mouse up ska rknas som klick eller ej
     
    var ind = new createjs.Shape();//indicator
    tl.ind = ind;//behver komma t den utifrn) 
    tl.addChild(ind);
    tl.y = -10;
	
    tl.correctMarker = addMarker(3);	
    tl.cursorMarker = addMarker(0);//anvnds ej
    tl.cursorMarker.uncache();//cannot be used before updateCache
    tl.correctMarker.uncache();
   // tl.cursorMarker.filters = [ new createjs.ColorFilter(3, 1, 0.5, 1, 0,0,0,0)];//filtered display object must be cached to be displayed!
    //tl.cursorMarker.updateCache();//just like calling cache(x,y,w,h) again but without bound params (i.e. the orignal cached bound is used)

    tl.cursorMarker.visible = false;
    tl.correctMarker.visible = false;
    
    tl.addChild(tl.correctMarker);
    //tl.addChildAt(tl.cursorMarker, 0);//obs att ven cursorLine finns, cursorMarker ska endast anvndas p mobiler 
    
    tl.cursorMarker.x = 0; tl.cursorMarker.y = 0;
    tl.correctMarker.x = 0; tl.correctMarker.y = 0;
    
    tl.spanMarker = new createjs.Shape();  
   // tl.spanMarker = new lib.SpanMarkerContainer();
    //tl.spanMarker.alpha = 0.2;
    tl.spanMarker.visible = false;
    //tl.spanMarker.stop();
    tl.cursorLine = new createjs.Shape();
    tl.intYearCursor = true;//om true fylls hela yearspan ut av cursor, i annat fall endast en pixeltunn linje. Stts i game efter question.intYear infr varje ny inputfas 
    tl.cursorYear;//spara i denna varje gng cursorLine berknas
    
    var clickedYearIndicator = new createjs.Container();//private och behandlas med public function (borde gra detsamma med ind)
    tl.addChild(clickedYearIndicator);

    
     //aktivera eventhandlers
    tl.on('tick', onTick);
    tl.maskedContainer.on("mousedown", onMousedown);


    ///eventhandlers///
    
    function onMousedown(e){

        //console.log(tl.name, this.name, e.currentTarget.name)//alla samma
	
	tl.removeChild(tl.baloon, false);//om specificerad child ej finns p displaychild hnder inget  annat n att false returneras
		
        tl.fixedPosition_atDragStart = tl.getPosition_px(e.localX);
	tl.fixedYear_atDragStart = tl.getYear(e.localX);//eftersom getYear anvnder fixedPosition mste vi frst bestmma r sedan position
	
	prev_drag_x = smx_atDragStart = stage.mouseX; //ska alltid var skrm/stage musposition
	prev_drag_y = smy_atDragStart = stage.mouseY; 
	//tl.fixedYear_atDragStart = tl.fixedYear;
	tl.scale_atDragStart = tl.scale;
	accu_x = accu_y = 0;
	
        //tl.on('tick', onTick);
        tl.on('pressup', onPressup)
    }
    
    function onTick(e){
	
	/*---------------------------------------------
	/ Om timeline invntar klick som svar p frga
	/---------------------------------------------*/
	if(tl.hasEventListener("answer") == true){
	    
	    /*--------------------------------------------------------------------------------------------------------
	    /stng av och p grafik beroende p om muspekare r p timeline
	    /(vi gr det inte via mouseover eftersom muspekare redan kan vara p timeline nr eventlistener lggs till)
	    ----------------------------------------------------------------------------------------------------------*/
	     var p = tl.globalToLocal(stage.mouseX, stage.mouseY);
	     
	     
	     //if(amask.hitTest(p.x,p.y)){
	     //eftersom amaks r en fylld rect r nedanstende snabbare (frutstter att setBounds() har anvnts)
	    if(p.x <= (amask.getBounds().x+amask.getBounds().width) && p.x >= amask.getBounds().x &&
	       p.y <= (amask.getBounds().y+amask.getBounds().height) && p.y >= amask.getBounds().y){
		
		//tl.spanMarker.visible = true;
		tl.drawSpan(p.x, "rgba(75,0,0,0.3)");
		
		tl.cursorLine.visible = true;
		tl.cursorLine.x = p.x;
		
		var rgbaString = "rgba(0,0,0,0.5)";//"rgba(255,200,200,0.75)";
		if(tl.scale <= 2 || !tl.intYearCursor ){
		    	
		    tl.cursorLine.graphics.clear().beginStroke(rgbaString).setStrokeStyle(2,0,0,10,true).moveTo(0,0).lineTo(0,56);
		    tl.cursorYear = tl.getYear(p.x);
		}
		else{
		     tl.cursorLine.x = tl.getPixel( Math.floor( tl.getYear(p.x) ) ); //tar reda p heltals pixel fr mitt av r
		     tl.cursorYear = Math.floor( tl.getYear(p.x) ) + 0.5;
		     tl.cursorLine.graphics.clear().beginFill(rgbaString).drawRect(0,0, tl.scale ,56);
		}
		
	     }
	     else{
		tl.spanMarker.visible = false;
		//tl.cursorLine.visible = false;
		tl.cursorLine.x = p.x;//ger  bra knsla att fortstta visa och flytta cursorLine
		tl.cursorMarker.visible = false;
	     }
	     
	}
	/*---------------------------------------
	/ Om svar ej invntas
	/---------------------------------------*/
	 else{
	   //tl.spanMarker.visible = false;
	 }
	 
	/*---------------------------------------
	/ Drag/pan timeline
	/---------------------------------------*/
        //if(tl.allowDrag === true && smx_atDragStart !== undefined){
	if(game.defaultTouchIsAllowed == false && smx_atDragStart != undefined){//defaultTouchIsAllowed anger om drag av documentbody via canvas ska vara mjlig
	    
            var dx = stage.mouseX-smx_atDragStart;
	    var dy = stage.mouseY-smy_atDragStart;
	  
	    
	    accu_x += Math.abs( stage.mouseX-prev_drag_x );
	    accu_y += Math.abs( stage.mouseY-prev_drag_y );
	    prev_drag_x = stage.mouseX;
	    prev_drag_y = stage.mouseY;
	       
	    //if( (Math.abs(dx) >= 2) || ( Math.abs(dy) >= 2) ){
	    if( accu_x >= 1 || accu_y >= 1 ){
		
		if(Math.abs(dx) > 2*Math.abs(dy)){
		      setTimeline(tl.fixedPosition_atDragStart, tl.fixedYear_atDragStart - (dx/tl.scale), tl.scale, "current" );
		}
		else if(Math.abs(dx) < 0.5*Math.abs(dy)){
		    setTimeline(tl.fixedPosition_atDragStart, tl.fixedYear_atDragStart, tl.scale_atDragStart * Math.pow(1.05, -dy), "current" );
		}
		else{
		    setTimeline(tl.fixedPosition_atDragStart, tl.fixedYear_atDragStart - (dx/tl.scale), tl.scale_atDragStart * Math.pow(1.05, -dy), "current" );
		}
		
		tl.ind.visible = false;
	        tl.spanMarker.visible = false;
		tl.cursorLine.visible = false;
		tl.drawTimeline()
		
		if(game.timelineDragHasBeenDone == false){
		    game.timelineDragHasBeenDone = true;
		    tl.dispatchEvent(new createjs.Event("drag1sttime"));
		}
  
	    }
        }
    }
    

    
    function onPressup(e){//mouseup must add a listener inside listener of mousedown! pressup is an alternative that works as expected 

        //ANSWER - if not dragged, it's an attempt to specify a year
       //if ( (Math.abs(stage.mouseX-smx_atDragStart) < 2) && ( Math.abs(stage.mouseY-smy_atDragStart) < 2) ) {
       if( accu_x < 2 && accu_y < 2 ){

	    
	    if(tl.hasEventListener("clicknotdrag") == true){
		var ne = new createjs.Event("clicknotdrag");
		tl.dispatchEvent(ne);
	    }
	    
	    if(tl.hasEventListener("answer") == true){
		
		//mouse events har localX & stageX s vi slipper anvnda tl.globalToLocal(stage.mouseX)
		//vi har redan sparat mouseX frn onTick handler i cursorLine.x men om touch anvnds s har inte cursorLine.x satts innan 
		console.log(tl.cursorLine.x, e.localX, e.stageX);
		
		if(tl.scale <= 2 || !tl.intYearCursor ){
		    tl.cursorLine.x = e.localX;
		    tl.cursorYear = tl.getYear( e.localX );
		}
		else{
		    tl.cursorLine.x = tl.getPixel( Math.floor( tl.getYear( e.localX ) ) ); //tar reda p heltals pixel fr mitt av r
		    tl.cursorYear = Math.floor( tl.getYear( e.localX ) ) + 0.5;
		}
		
		tl.manualAnswer = true;
		tl.dispatchEvent("answer");
		

	    } 
        }
       // tl.removeEventListener('tick', onTick);
        tl.removeEventListener('pressup', onPressup);
	smx_atDragStart = undefined;
    }
    tl.removeClickedYearIndicator = function(){
	clickedYearIndicator.removeAllChildren();
    }

    //methods
    function getPosition(yr) {
	return ( (getPixelExact(yr)-amask.getBounds().x)/amask.getBounds().width)
    }
    function getPosition_px(px) {
	return ( (px-amask.getBounds().x)/amask.getBounds().width )
    }
    //OBS! AVRUNDNING (fr pixel grafiks skull) allts br avrundat vrde ej omvandlas till r igen utan r vrdet br sparas och anvndas som grundvrde
    function getPixel(yr){
	var originyear/*year at x = 0*/ = tl.fixedYear + ((0.5-tl.fixedPosition)*amask.getBounds().width)/tl.scale
	return Math.round((yr-originyear)*tl.scale); 
    }
    function getPixelExact(yr){
	var originyear/*year at x = 0*/ = tl.fixedYear + ((0.5-tl.fixedPosition)*amask.getBounds().width)/tl.scale
	return (yr-originyear)*tl.scale; 
	
    }
    function getYear(px){
	var originyear/*year at x = 0*/ = tl.fixedYear + ((0.5-tl.fixedPosition)*amask.getBounds().width)/tl.scale
	return originyear+px/tl.scale;
    } 
    function getYearAtMaskEnd(){
	return Math.ceil( tl.getYear( amask.getBounds().x+amask.getBounds().width  ) );
    }
    
    function setTimeline(fixedPosition, fixedYear, scale, callbackFunction){//obs p flera stllen i koden anvnds inte denna utan properties stts direkt
	tl.fixedPosition = fixedPosition;
	var dYear = fixedYear - tl.fixedYear;
	tl.fixedYear = fixedYear;
	
	
	
	if(scale > tl.maxScale)scale = tl.maxScale;
	if(scale < tl.minScale)scale = tl.minScale;
	var dScale = Math.log(scale)/Math.log(10) - Math.log(tl.scale)/Math.log(10);
	tl.scale = scale;
	
	/*
	dispatchEvent("set")//kallar callback function som skickades d timeline.addEventListener("set", callbackFunction)
	//lngsammare variant med mer mjligheter
	var e = new createjs.Event("set", false, false);
	e.dYear = //kan fylla e med egna properties & values
	dispatchEvent(e);
	*/
	
	//egen lttvikts variant med endast en callback funktion (som antingen skickas med eller har satts innan)
	//och skickar bara till denna och inte till alla ev. listeners (vilket ltt kan efterliknas med en listeners[]) 
	if(!callbackFunction)return;
	if(callbackFunction === "current")callbackFunction = tl.callbackFunctionForSet;
	if(callbackFunction != undefined)callbackFunction({dYear:dYear, dScale:dScale});
	
	//efter callbackfuntionen har verkat (returnerat) kommer vi tillbaka hit (i js behver man dock inte skriva ut avslutande return d det grs vid block slut om inget return ptrffas)
	return;
    }

    
    //lyr =  tl.getYear( amask.getBounds().x ) ;
    //lyr =  tl.fixedYear + ((0.5-tl.fixedPosition)*amask.getBounds().width)/tl.scale   +  px/tl.scale;
    //tl.scale =  tl.fixedYear + ((0.5-tl.fixedPosition)*amask.getBounds().width)/lyr   +  px/lyr;
    
	//var leftMaskEdge_yr = Math.floor( tl.getYear( amask.getBounds().x ) );
	//var rightMaskEdge_yr = Math.ceil( tl.getYear( amask.getBounds().x+amask.getBounds().width  ) );
  
    tl.drawInd = function(maxDevYears ){
	
	ind.visible = true;
	ind.graphics.clear();
	ind.y = -10;
	
	//om den ska vara rsbaserad - R ALLTID DET EFTERSOM VI OMVANDLAR PIXELDEV TILL YEARSDEV S ATT SKALNING KAN GRAS UNDER EN FRGA
	if(maxDevYears != undefined ){

	    dev = tl.scale*maxDevYears;
	    ind.graphics.beginLinearGradientFill( ["rgba(0,204,51,0)", "rgba(0,204,51,1)", "rgba(0,204,51,0)"], [0, 0.5, 1], -dev,0,dev,10).drawRect(-dev,0,dev*2,10)//vektorn fr grad. anges med x0, y0, x1, y1 medan drawrect anges med x, y, width, height!
	    ind.cache(-dev,0,dev*2,10);

	}
	//om den ska vara pixelbaserad
	//else {
	//    //ind.graphics.beginLinearGradientFill( ["rgba(0,204,51,1)", "rgba(0,204,51,1)", "rgba(0,204,51,1)"], [0, 0.5, 1], -maxDevPixels,0,maxDevPixels,10).drawRect(-maxDevPixels,0,maxDevPixels*2,10)//vektorn fr grad. anges med x0, y0, x1, y1 medan drawrect anges med x, y, width, height!
	//    ind.graphics.beginLinearGradientFill( ["rgba(0,204,51,0.2)", "rgba(0,204,51,1)", "rgba(0,204,51,0.2)"], [0, 0.5, 1], -gameData.maxDevPixels,0,gameData.maxDevPixels,10).drawRect(-gameData.maxDevPixels,0,gameData.maxDevPixels*2,10)//vektorn fr grad. anges med x0, y0, x1, y1 medan drawrect anges med x, y, width, height!
	//    //ind.graphics.setStrokeStyle(2).beginStroke("#ff0000").moveTo(-maxDevPixels,0).lineTo(-maxDevPixels,10).moveTo(maxDevPixels,0).lineTo(maxDevPixels,10);
	//
	//    ind.cache(-gameData.maxDevPixels,0,gameData.maxDevPixels*2,10);
	//}
    }
    
    function drawTimeline(){
	
	//var min_yrsp_for_cur_scale = min_pxsp/tl.scale;
	var max_yrsp_for_cur_scale = max_pxsp/tl.scale;
	
	//skalan (som helt och hllet bestms av slider) avgr frhllande mellan pixspan och yearspan
	//pixspan r kontinuerlig mellan minimum pixspan (t.ex. 5) och 10x minimum pixspan (50)
	//men yearspan hoppar mellan 10 bilj till 1 bilj till 100 milj ... till 10 till 1 till 1/12

	for(var i=0, l=yrsps.length; i<l; i++){
	    yr = yrsps[i];
	    //endast ett av yrsps[] vrden passar 
	    //if(yr >= min_yrsp_for_cur_scale && yr <= max_yrsp_for_cur_scale){
	    if(yr <= max_yrsp_for_cur_scale){	
		yrsp = yr; break;
	    } 
	}
	//nu nr yrsp r bestmt vet vi slutligen current pxsp.
	pxsp = tl.scale*yrsp //pxspa blir normalt mellan 5 och 50 men om yrsp = 1/12 och scale r precis ver 50 (max_pxsp = 50) kan pxsp bli t.ex. 55*(1/12) = 4.58
	
	//masked container r ett tomt movieclip som maskas av en shape gjord i flash authoring tool
	//(masked container var tvungen att inehlla en shape fr att exporteras av toolkit, men denna shape maskas bort)    
	tl.maskedContainer.removeAllChildren()
	tl.unmaskedContainer.removeAllChildren();
	
	tl.maskedContainer.addChild(tl.spanMarker);
	//tl.maskedContainer.addChild(ind);
	tl.maskedContainer.addChild(tl.cursorLine);
	
	tl.shape = new createjs.Shape();
	
	tl.maskedContainer.addChild(tl.shape);
        tl.shape.graphics.beginStroke("#ffffff").setStrokeStyle(4,0,0,10,true).moveTo(- (game.canvasOrigWidth/2),0).lineTo((game.canvasOrigWidth/2),0);
	
	edge_yr = tl.getYear(-game.canvasOrigWidth/2);//r (kan vara i decimal form) som motsvarar skrmens vnstra kant
	start_yr = Math.floor(edge_yr/yrsp)*yrsp;//frsta/vnstra r som motsvarar en tick/streck
	//var firstYearFor10xYearSpan = Math.floor(edge_yr/(10*yrsp))*10*yrsp;
	var end_yr = tl.getYear(game.canvasOrigWidth/2);
	leftMaskEdge_yr = Math.floor( tl.getYear( amask.getBounds().x ) );
	rightMaskEdge_yr = Math.ceil( tl.getYear( amask.getBounds().x+amask.getBounds().width  ) );
    
	//var start_px = tl.getPixel(start_yr);
	var hi_x_px_txt = -10000//-Infinity
	
	//brja vid r frsta tick/streck och hoppa fram tick fr tick
	//for(var yr = firstYearFor10xYearSpan; yr < end_yr; yr += (10*yrsp)){
	//    var x = tl.getPixel(yr);
	//    tl.shape.graphics.setStrokeStyle(3,0,0,10,true).moveTo(x, 0).lineTo(x,11);  
	//    drawYear(yr);
	//}
	
	
	/*-----------------------------------------------------------------
	 rita sjlva timeline (horisontell linje + vertikala streck/ticks)
	------------------------------------------------------------------*/
	if(yrsp == 1/12){
	    for(var yr = leftMaskEdge_yr; yr < end_yr; yr += yrsp){
		var x = tl.getPixel(yr);
		if(yr < Math.round(yr)+0.01 && yr > Math.round(yr)-0.01 ){//yr kommer inte att bli heltal utan t.ex. 1987.999999 istllet fr 1988
		    //draw long line
		    tl.shape.graphics.setStrokeStyle(3,0,0,10,true).moveTo(x, 0).lineTo(x,11);
		   
		    drawYear(yr);
		}
		else{
		    tl.shape.graphics.setStrokeStyle(1,0,0,10,true).moveTo(x, 0).lineTo(x,5);
		}
	    }
	}
	else{
	    for(var yr = start_yr; yr < end_yr; yr += yrsp){
		var x = tl.getPixel(yr);
		if(yr % yrsp == 0){
		    //draw short line 
		    tl.shape.graphics.setStrokeStyle(1,0,0,10,true).moveTo(x-.5, 0).lineTo(x,5);
			////kolla aktuellt pixelspan - om nra grnsen fr nytt year span s skriv ut r ven hr s vi vegng dr r skrivs ut innan indelnings streck skrivs ut
			if ( tl.scale*yrsp > 0.95*max_pxsp)
			{
			    drawYear(yr);
			}	
		    
		    if( yr % (5*yrsp) == 0){
			
			//draw medium line
			tl.shape.graphics.setStrokeStyle(2,0,0,10,true).moveTo(x-1, 0).lineTo(x,7);
			//kolla aktuellt pixelspan - om stort s skriv ut r ven hr
			if (( tl.scale * yrsp) > (5*min_pxsp))
			{
			    drawYear(yr);
			}		    
		    }
		    if( yr % (10*yrsp) == 0){
			//draw long line
			tl.shape.graphics.setStrokeStyle(3,0,0,10,true).moveTo(x-1.5, 0).lineTo(x,11);
		       
			drawYear(yr, true);
		    }
		}
	    }
	}
	
	function drawYear(yr, prio){
	  
	    var s = numberToReadableString(yr);
  	    
	    //var tF = new createjs.Text(s, "14px arial", "#ffffff");
	     var tF = new createjs.BitmapText(s, fontSheet);
	    
	    tF.prio = prio;
	    
	    tl.maskedContainer.addChild(tF);
	    tF.y = 12;
	    tF.x = x;
	    
	    var b = tF.getBounds();
	    
	    //tF.textAlign = "center";//vanlig text
	    tF.x -= Math.floor(b.width/2);//endast bitmapText
	    if (yr < 0) tF.x -= 3;//ignorera minustecekens del av width
	    tF.spaceWidth = 3;//endast bitmapText
	    tF.letterSpacing = 1;
	    
	    //verlappar nyss utritad/tillagd text den innan tillgagda texten? 
	    //if ( (x-b.width/2) <= (hi_x_px_txt+5)) {//vanlig text som r center aligned fr halva textinnehllet till hger om x=0
	    if ( x <= (hi_x_px_txt+15)) {//bitmaptext har x=0 vid textinnehlls vre vnsta hrn (om regX och regY = 0)
		
		//r det nyss utritade ett 10x tal?
		if(tF.prio == true){
		    
		    var prevTF = tl.maskedContainer.getChildAt(tl.maskedContainer.numChildren-2)
		    //ta bort fregende r om det inte r ett 10x tal
		    if(prevTF.prio == false){
			 tl.maskedContainer.removeChild(prevTF)
			 hi_x_px_txt = x+b.width;
			 
		    }
		    //annars ta bort nyritade
		    tl.maskedContainer.removeChild(tF); 
		}
		//ta bort nyss utritade r
		else tl.maskedContainer.removeChild(tF);
	    }
	    else{
		//hi_x_px_txt = x+b.width/2;
		hi_x_px_txt = x+b.width;
		//tF.cache(b.x,b.y,b.width,b.height);//OBS! b (bound obj) nollstlls nu!CACHA EJ bitmapText
	    }   
	}
	
	var m, db;
	//berkna synliga events (anvnds ven i ontick) och skapa descBubbles/labels och markers/baloons
	tl.visibleEvents = [];
	for(var i=0, l = tl.defEvents.length; i<(l-1); i++){//inkluderar inte sista d det r den hndelse som senast tryckts ut och den ska ha prio och ligga verst (se ca 10 rader lngre ned)
	
	    var ev = tl.defEvents[i]
	    //om event r inom visat spann och om skalan r strre en skalan som den som r angett fr event/question
	    if (ev.a < rightMaskEdge_yr && ev.a > leftMaskEdge_yr){// && tl.scale >= ev.minScale/10) {
	    //if (ev.a < end_yr && ev.a > start_yr){// && tl.scale >= ev.minScale/10) {
		//vi lgger till dem ven om de inte r fullt uppskalade
		tl.visibleEvents.push(ev);
	    }
	}
	//sortera s att de ldsta verlappar yngre
	tl.visibleEvents.sort( function(a, b){return b.a-a.a} ); //a-b ger minsta tal frst, b-a skulle ge hgsta frst
	tl.visibleEvents.push(tl.defEvents[l-1]);//lgger nu till senast tryckta hndelse s att dess desc bubble hamnar verst
	for(i=0, l = tl.visibleEvents.length; i<l; i++){
		
		ev = tl.visibleEvents[i];
		
		var scale = 1;
		//if(ev.minScale > 0){
		//    scale = tl.scale/ev.minScale;
		//    if(scale > 0.01){
		//	m = tl.unmaskedContainer.addChild( addMarker( ev.1) );
		//	m.setYear(ev.a, ev.isIntYear, ev.isCirca);
		//	m.position();
		//    }
		//    if(scale < 1){
		//	m.scaleX = m.scaleY = scale
		//    }
		//    //lgg dem till visibleEvents (s att de avgrnsar span p timeline) endast om de verkligen nr upp till minScale 
		//    //else tl.visibleEvents.push(ev);
		//}
		//else
		m = tl.unmaskedContainer.addChild( addMarker(1) );
		m.setYear(ev.a, ev.isIntYear, ev.isCirca, ev.day);
		m.position();

		
		if(ev.d != ""){
		    db = tl.unmaskedContainer.addChild( addDescBubble( ev.d, ev.a ) );
		    m.db = db; db.m = m;
		    if(scale < 1){
			// db.scaleX = db.scaleY = scale
			db.visible = false;//visa label endast nr baloon/marker ntt full storlek
		    }
		}
	    
	}

	tl.correctMarker.position();
	//ind.x = tl.correctMarker.x; //ta istllet bort om man brjar skala timeline
    }
    tl.removeDefEvents = function (){
	tl.defEvents = [];
    }
    tl.removeNewEvents = function (){
	//tl.newEvents = [];
    }
    function addMarker(color){

        var m = new lib.Marker();
	
	if(color === undefined)color = 0;
	m.gotoAndStop(color);
	
	m.tF0 = new createjs.Text("", "16px Tahoma, sans-serif", "#ffffff");
	m.addChild(m.tF0);
	m.tF0.lineWidth = null;//om null anpassas lineWidth efter textlngd och radbryt grs manuellt (kan ocks gras i flash authoring tool med cirkelindikator istllet fr kvadrat)
	m.tF0.lineHeight = 0;
	m.tF0.textAlign = "center";//default r left
	
	m.setYear = function(yr, isIntYear, isCirca, day, scaleToAdjustTo){//endast cursorMarker som anvnder scaleToAdjustTo eftersom de andra ska se likadana ut oavsett skala
	   
	    m.yr = yr;//anvnds fr cursorMarker
	   
	    var mw;//maxwidth fr text - beror p hur texten skrivs ut
	    if(!isIntYear && tl.scale >= 12){
		m.tF0.text = yearToDate(yr, day)
		mw = 50;
	    }
	    else{
		if(isCirca == true){
		    if(yr <= -1000000)
			m.tF0.text = "ca "+numberToReadableString(Math.floor(yr),true,scaleToAdjustTo);//true str fr two lines som alla markers ska anvnda
		    else
			m.tF0.text = " ca\n"+numberToReadableString(Math.floor(yr),true,scaleToAdjustTo);//true str fr two lines som alla markers ska anvnda
		   
		}
		else m.tF0.text = numberToReadableString(Math.floor(yr),true,scaleToAdjustTo);//true str fr two lines som alla markers ska anvnda
		
		mw = 56;
	    }
	   
	    
	    m.tF0.x = 0;
	        
	    //maxWidth medfr skalning i x-led s att text ryms inom satt maxWidth.
	    //Men denna skalning pverkar inte scaleX och vi kan drfr ej anpassa scaleY s att vi fr normal font proportion!
	    //m.tF0.maxWidth = mw;
    
	    //Det r dock ltt att gra egen variant
	    var tw = m.tF0.getBounds().width;
	    if (tw > mw)
	    {
	       m.tF0.scaleY = m.tF0.scaleX = mw/tw;
	    }
	    //kolla nu hjd fr att justera pos i y-led
	    var th = m.tF0.getBounds().height;
	    m.tF0.y = -75+(42-th)/2;//75 och 42 r vrden som passar rdande markrgrafik
	    
	    var b = m.getBounds()
	    m.cache(b.x,b.y,b.width+7,b.height+10);
	}
	
	/*Variant fr multiline med fix width & fix height. Om text ej ryms inom width sker radbrytning och drmed frlngning i y-led. Krver satt .lineWidth eller kvadratindikator i i flash*/
	//adjustTextSize(m.tF0, 40, 14, "arial, sans-serif", 1.1);
	m.position = function(){
	    //stt position efter r
	    m.x = getPixel(m.yr);m.y = 0;
	}

	
	m.addEventListener('mouseover', function (e){
	    
	    m.parent.setChildIndex(m, m.parent.getNumChildren()-1)
	    //cursorMarker har ingen db
	    if(m.db === undefined){
		console.log("no descbubble");
	    return;
	    }
    	    
	    m.parent.setChildIndex(m.db, m.parent.getNumChildren()-1)
	});
	
	//shapes bounds stts EJ automatiskt
	//vi skapar drfr redan hr och anvnder sedan i setYear
	m.setBounds(-34,-78,68,78);
        
	m.getChildAt(0).shadow = new createjs.Shadow("rgba(0,0,0,0.4)", 2,5,5);

	return m;
    } 
  
    function addDescBubble(text, yr){
	
	var db = createBaloonHelp(text, {font:"12px Tahoma, sans-serif", color:"#060", lineWidth:100, textAlign: "center"}, {strokeThickness:2, strokeColor:"#fff", fillColor:"#aaffaa", padding:5, radius:4, arrowH:6, arrowDir:"north", shadow:new createjs.Shadow("rgba(0,0,0,0.4)", 2,5,5)});
	
	db.mouseChildren = false;//makes the container db the only possible e.target (not necessary if e.currentTarget (the event dispatcher) is used)	  
	db.addEventListener('mouseover', function (e){

    	    db.parent.setChildIndex(db, db.parent.getNumChildren()-1)
	    db.parent.setChildIndex(db.m, db.parent.getNumChildren()-1)
	});
	
        db.x = getPixel(yr); db.y = 50;
	return db;
    }
    
    //Timeline stts genom att stta dess .fixedYear, .fixedPosition, och .scale. Scale ndras alltid via slider.
    //Nedanstende funktioner berknar fram ovanstende parametrar utfrn olika givna frutsttningar.
    //Istllet fr att direkt stta timeline skickas paramterarna tillbaka i ett objekt
    //p s stt kan slider anvndas fr sttning av scale och tweening av sttandet kan ocks gras
    
    //rrlig skala och span (skala ger span)
    //passar bst fr question years i frhistorisk tid
    //answeryears position hamnar lngst till vnster vid strsta mjliga inzoom och lngst till hger vid minsta inzoom
    tl.calcRandomScale = function(fixedYear/*mste vara strre n maxLeftYear, e.g. this date*/, fixedPosition, minLeftYear/*e.g. creation of universe*/, maxLeftYear/*answer year*/){
	
	if(fixedYear < (maxLeftYear+10))fixedYear += 10;
	if(maxLeftYear < minLeftYear)minLeftYear = -15000000000;
	
	var scaleForMinLeftYear = fixedPosition*amask.getBounds().width/(fixedYear-minLeftYear);
	var scaleForMaxLeftYear = fixedPosition*amask.getBounds().width/(fixedYear-maxLeftYear);
	
	var minLog = Math.log(scaleForMinLeftYear)/Math.LN10;
	var maxLog = Math.log(scaleForMaxLeftYear)/Math.LN10;
	
	var randomLog = minLog+Math.random()*(maxLog-minLog);
	var scale = Math.pow(10, randomLog);
	
	return {fixedYear:fixedYear, fixedPosition:fixedPosition, scale:scale};
    }
    
    //frutbestmt span (ev. med viss variation)
    tl.calcFromEdgeValues = function(minLeftYear, maxLeftYear/*t.ex question.year eller samma som minLeftyear fr fixt vrde*/, minRightYear/*t.ex. question.year eller samma som maxRightYear fr fixt vrde*/,
				     maxRightYear, fixedYear/*question year*/, limitScale){
	
	if(minLeftYear > maxLeftYear)minLeftYear = maxLeftYear;
	if(minRightYear > maxRightYear)maxRightYear = minRightYear;
	
	var leftYear = minLeftYear+Math.random()*(maxLeftYear-minLeftYear);
	var rightYear = minRightYear+Math.random()*(maxRightYear-minRightYear);
	
	if(limitScale){
	    //begrnsa skala s att yrsp between ticks inte blir 1/12; detta kan medfra att minleftyear/maxrightyear under/verskrids
	    var min_yrsp_timeline = Math.ceil(amask.getBounds().width/max_pxsp);
	    if( (rightYear - leftYear) < min_yrsp_timeline){
		rightYear += min_yrsp_timeline/2;
		leftYear -= min_yrsp_timeline/2;
	    }
	}
	var scale = amask.getBounds().width/(rightYear-leftYear);
	fixedPosition = (fixedYear-leftYear)/(rightYear-leftYear);
	return {fixedYear:fixedYear, fixedPosition:fixedPosition, scale:scale};
    }
    
    //frutbestmd skala (ev. med viss variation)
    tl.calcRandomPosFromLogOfYrSpTick = function(fixedYear/*i.e., question.year*/, scale, totalNumYears/*2ndra alternativ om scale == undefined*/, log_yrsp, pxsp, showFuture){
	
	//ett alternativ till att ange scale direkt r att ange hur mnga r tidslinjen ska rymma totalt p skrmen
	if(scale == undefined){
	    if(totalNumYears != undefined){
		scale = amask.getBounds().width/totalNumYears;
	    }
	    //annars berknar vi skala p angivna pixel och yearsspan mellan ticks
	    //och om de inte r angivna berknas tick year span p efterskt rs storlek och tick pixel span slumpas
	    else{
		if(log_yrsp == undefined){
		    var size = date.floatYear - fixedYear;
		    log_yrsp = (Math.log_yrsp(size)/Math.LN10);
		    log_yrsp -= 1.5;
		    if(log_yrsp < 0)log_yrsp = 0;
		    //log_yrsp = Math.floor(log_yrsp);
		    //if(log_yrsp > 0)log_yrsp--;
		    
		}
		if(pxsp == undefined)pxsp = min_pxsp + Math.random(max_pxsp - min_pxsp);
		scale = pxsp/Math.pow(10,log_yrsp);
	    }
	}
	fixedPosition = Math.random();
	
	if(!showFuture){ 
	    var datePos = fixedPosition + ((date.floatYear-fixedYear)*scale)/amask.getBounds().width;
	    if(datePos < 1)fixedPosition += (1-datePos)
	}
	
	return {fixedYear:fixedYear, fixedPosition:fixedPosition, scale:scale};
    }
    
    //denna anvnds efter att timeline vrden har tagits fram med ngon av ovanstende funktioner
    //bredden p spannet som detta r befinner sig i kollas 
    //om spannet r fr smalt fr att funka p mobil, justeras skalan uppt
    //dessutom scrollas s att tminstone en av markrerna till vnster och hger om efterfrgat r alltid visas p skrmen (och med viss optimering av denna position)
    tl.adjustSpanWidth = function (fixedYear, fixedPosition, scale, answerYear){
	
	var MIN_WIDTH = 100;
	var TIMELINE_WIDTH = amask.getBounds().width;
	
	
	var eventLeftOfAnswer = undefined;
	var eventRightOfAnswer = undefined;
	
	//sortera events efter deras r
	tl.defEvents.sort( function(a, b){return a.a-b.a} ); //a-b ger minsta tal frst, b-a skulle ge hgsta frst
	
	for(var i=0, l = tl.defEvents.length; i<l; i++){
	   
	    if(tl.defEvents[i].a >= answerYear && eventLeftOfAnswer == undefined){
		
		eventLeftOfAnswer = tl.defEvents[i-1];
		eventRightOfAnswer = tl.defEvents[i]; 
		break;
	    }
	}
	
	//ta reda p avstnd i pixel mellan omkringliggande markrer
	var interval_yr = eventRightOfAnswer.a-eventLeftOfAnswer.a;
	var interval_px = scale*interval_yr;
	
	//skala upp om avstnd r fr litet fr tryck p mobil
	if(interval_px < MIN_WIDTH )scale = MIN_WIDTH/interval_yr;
	    
	//om vnster och hger  event bda befinner sig p synligttimeline kan vi returnera
	var leftMarkerPxPos =  fixedPosition*TIMELINE_WIDTH - (fixedYear-eventLeftOfAnswer.a)*scale;
	var rightMarkerPxPos = fixedPosition*TIMELINE_WIDTH + (eventRightOfAnswer.a - fixedYear)*scale;
	console.log("leftMarkerPxPos", leftMarkerPxPos, "rightMarkerPxPos", rightMarkerPxPos )
	if(leftMarkerPxPos > 0 && rightMarkerPxPos < TIMELINE_WIDTH ){
	    
	    return {fixedYear:fixedYear, fixedPosition:fixedPosition, scale:scale};
	}
	
	
	//else if(interval_px > (1.9*TIMELINE_WIDTH)/*det r halva vrdet r det som mste begrnsas s att vi alltid kan scrolla in markr utan att efterfrgat svar scrollar ut)*/){
	//    scale = (1.9*TIMELINE_WIDTH)/interval_yr;
	//}
	
	
	//avstnd mellan rtt svar och de nrmsta redan utsatta markrerna
	var l_dist_yr = answerYear-eventLeftOfAnswer.a;
	var r_dist_yr = eventRightOfAnswer.a-answerYear;
	
	var l_dist_px = scale*l_dist_yr;
	var r_dist_px = scale*r_dist_yr;
	
	var leftestPos, rightestPos, actualPos;//mjliga positioner och slutlig position fr rtt svar
	
	if(l_dist_px <= r_dist_px){
	    
	    // Om avstnd (mellan left marker och rtt svar) r s stort att den panning som krvs fr att f left markr synlig till vnster kommer att flytta rtt
	    //svar s lngt t hger att det inte ryms ett minimavstnd mellan rtt svar och timelines hgra kant:
	    // Isfall mste vi skala ned innan vi pannar in vnstra markr
	    if(l_dist_px > (TIMELINE_WIDTH-10-MIN_WIDTH)){
		scale = (TIMELINE_WIDTH-10-MIN_WIDTH)/l_dist_yr;
		l_dist_px = scale*l_dist_yr;
	    }
	    
	    fixedYear = eventLeftOfAnswer.a;
	    leftestPos = MIN_WIDTH; //dvs t.ex. 100 px till hger om timelines vnstra kant
	    rightestPos = TIMELINE_WIDTH - l_dist_px;//s att rtt svar hamnar precis till vnster om timelines hgra kant
	    if(rightestPos > (TIMELINE_WIDTH-MIN_WIDTH) )rightestPos = (TIMELINE_WIDTH-MIN_WIDTH) ;//verkar ondig - gller bara om avstnd mellan left markr
	    //och rtt svar r mindre n min_width och det ska vl inte vara mjligt hr - jo, min width har ju innan jmfrts med avstnd mellan left och right marker
	  
	    
	}
	else{
	    
	    if(r_dist_px > (TIMELINE_WIDTH-10-MIN_WIDTH)){
		scale = (TIMELINE_WIDTH-10-MIN_WIDTH)/r_dist_yr;
		r_dist_px = scale*r_dist_yr;
	    }
	    fixedYear = eventRightOfAnswer.a;
	    rightestPos = (TIMELINE_WIDTH-MIN_WIDTH);
	    leftestPos = r_dist_px;
	    if(leftestPos < MIN_WIDTH)leftestPos = MIN_WIDTH;
	    
	    
	}
	
	actualPos = leftestPos + Math.random()*(rightestPos-leftestPos);
	fixedPosition = actualPos/TIMELINE_WIDTH;
			  
	console.log("left ev", eventLeftOfAnswer.a, "right ev", eventRightOfAnswer.a, "interval_px", interval_px)//, scale*(eventRightOfAnswer.a-eventLeftOfAnswer.a) )
	console.log("ld_px", l_dist_px, "rd_px", r_dist_px, "fixyear", fixedYear, "leftest", leftestPos, "rightest", rightestPos, "actual", Math.floor(actualPos), "fixpos", Math.floor(fixedPosition) )

	return {fixedYear:fixedYear, fixedPosition:fixedPosition, scale:scale};
    }
    tl.drawSpan = function(x, rgbaString){
	
	tl.spanMarker.visible = true;;
	
	var leftSpanEdge_yr = leftMaskEdge_yr, rightSpanEdge_yr = rightMaskEdge_yr;
	var yr = tl.getYear(x)
	
	
	for(var i=0, l = tl.visibleEvents.length; i<l; i++){
	    var ev = tl.visibleEvents[i]

	    if(ev.a <= yr && ev.a > leftSpanEdge_yr)leftSpanEdge_yr = ev.a;
	    if(ev.a >= yr && ev.a < rightSpanEdge_yr)rightSpanEdge_yr = ev.a;
	}
	var width = tl.scale*(rightSpanEdge_yr-leftSpanEdge_yr);
	
	if(rgbaString == undefined)
	    rgbaString = "rgba(0,204,51,1)";
	    //rgbaString = "rgba(255,200,200,0.3)";	
	
	tl.spanMarker.graphics.clear().beginFill(rgbaString).drawRect(getPixel(leftSpanEdge_yr),0, width ,56);
	//tl.spanMarker.graphics.clear().beginFill("rgba("+r+","+g+","+b+","+a+")").drawRect(getPixel(leftSpanEdge_yr),0, tl.scale*(rightSpanEdge_yr-leftSpanEdge_yr) ,56);
	//tl.spanMarker.spanMarker.rect.scaleX = tl.scale*(rightSpanEdge_yr-leftSpanEdge_yr)/100;
	//tl.spanMarker.x = getPixel(leftSpanEdge_yr);
    }
    return tl;
}

