var gameData = gameData || {};//globalt objekt 

function preload(callbackFunction){
    
    //allra frst br en loading grafik laddas in som visas och uppdateras fr varje ny fil som laddas in
    //om bitmap grafik ska visas hr mste den sklart ha laddats in via tag loading 
    
    var preloaderText = new lib.PreloaderText;
    stage.addChild(preloaderText);
    preloaderText.x = 83//(800-640)/2;
    preloaderText.y = 106//(450-80)/2;
    
 	    var bg = new createjs.Shape();
	    drawBg(bg, canvas.width, canvas.height,9);
	    stage.addChildAt(bg,0);

    
    var amask = new createjs.Shape();
    amask.graphics.beginFill("#000)").drawRect(0,0,640,80);

    amask.scaleX = 0;
    //mask does not need to be on stage but can be and is then visible even if functioning as a mask
    //as a mask it will always be positioned like it is in the same parent container as the masked object - irrespective if it really is added to stage or not
   preloaderText.getChildAt(1).mask = amask;
   

    
    //sounds can be preloaded in two ways:
    // 1) createjs.Sound.registerSound(s). A fileload event will fire for each file but there is no complete event so a counter has to be used.
    //Manuell registrering mjliggr sttandet av default volym!
    // 2) createjs.LoadQueue. A ordinary preloader that also can load images, etc.
    //Registering must still be done but the preloader will handle this automatically if LoadQueue.installPlugin(createjs.Sound) has been instructed.
   
    createjs.Sound.alternateExtensions = ["ogg"];//om inte mp3 stds (firefox & opera) letar den efter fil med samma namn men av ogg-typ
    
    //Ljud spelas via en browser plugin. Som default frsker createjs.Sound anvnda Web Audio och om det misslyckas istllet HTMl Audio.
    //Man kan dock registera ordning valfritt och d ven vlja ytterliggare plugins som Flash och Cordova. Registrering medfr att ordinarie ordning inte fljs.
    //Notera att Web Audio krver helt inladdad ljudbuffer innan uppspelning. Detta krver XHR-loading och funkar inte frn local dator (inte ens nr local server anvnds)
    
    //createjs.FlashAudioPlugin.swfPath = "extlibs/"; //skvg till FlashAudioPlugin.swf. Enligt docs ska FlashAudioPlugin-X.X.X.min.js best av kompilerade FlashAudioPlugin.swf + swfObject.js men oklart om alla behvs eller inte. Fr hursomhelst inte det att funka.
    //createjs.Sound.registerPlugins([createjs.FlashAudioPlugin]);
    //createjs.Sound.registerPlugins([createjs.WebAudioPlugin, createjs.HTMLAudioPlugin, createjs.FlashAudioPlugin]);//flashaudio plugin som fallback om inte de tv ordinarie funkar
    
//
var counter = 0;
//    createjs.Sound.registerSounds(
//	[
//	 {src:"sounds/correctanswer.mp3", id:"correctanswer"},
//	 {src:"sounds/wronganswer.mp3", id:"wronganswer"}
//	]
//    );


   //createjs.Sound.addEventListener("fileload", onSoundFileLoad);
    
//    function onSoundFileLoad(e) {
//	console.log("soundfile loaded:", e.id, e.src);
//	//To play sound either id or src can be used. Note that both are strings.
//	//createjs.Sound.play(e.id) or createjs.Sound.play(e.src)
//	counter++;
//	if(counter == 2);
//    }
    
    

    //bildfiler mste finnas p server (local server funkar) fr att preloader inladdning ska funka. I annat fall mste tag loading anvndas.
    
    imgs = imgs||{};//createjs toolkit anvnder imgs object med bitmapfilernas id som property. imgs objektet r redan skapat i assets.js och r hr bara som pminnelse

    loadQueue = new createjs.LoadQueue(false);//did not work without false (but did work (without false) before?!)
    loadQueue.installPlugin(createjs.Sound);//behvs fr att kunna ladda in ljud med LoadQueue s att den skter registrering av ljud automatiskt
    loadQueue.addEventListener("fileload", onFileLoad);
    loadQueue.addEventListener("complete", onLoadComplete);
    loadQueue.addEventListener("progress", onProgress);

    //Fla-fil med assets som har bitmap kommer att spara dessa i toolkit specificierad katalog (default i images) och anvnder samma filnamn som bitmap filen som importerades
    //men utan eventuella underscore/dashes (om importkatlaog r lika med exportkatalog och inga underscore/dashes anvnds blir det allts samma fil). Koden fr att ladda in dessa bitmaps finns inte i toolkit skapad .js-fil utan i toolkit skapad .html-fil.
    //Klipp ut denna kod och klistra in hr i stllet. id strngen som skapas r densamma som filnamnet utan filndelse.
    //Det som laddas in blir html-element och kan kommas t via documnet.getElementById("id") eller via loadQueue.getResult("id") eller via imgs["id"]
    //asset.js hmtar bitmap via deras id s en game specifik asset.js kan ven innehlla bitmaps som anvnds till alla timelines spel och ligger i ../_images
    loadQueue.loadManifest(//loadFile() for single file. Manifest r en array av objekt med src och id properties
	[
		//src r alltid relativt index.html inte denna fil!
		
		/*----------------------
		 * _images eller images
		 * --------------------*/
		
		//fr gemensamma flash assets
		{src:"../_images/cardback.png", id:"cardback"},
		{src:"../_images/cardfront.png", id:"cardfront"},
		{src:"../_images/startbuttondeluxe.png", id:"startbuttondeluxe"},
		{src:"../_images/continuebuttondeluxe.png", id:"continuebuttondeluxe"},
		{src:"../_images/timelinearrow.png", id:"timelinearrow"},
		{src:"../_images/whitestar.png", id:"whitestar"},
		{src:"../_images/playbutton.png", id:"playbutton"},
		{src:"../_images/startbutton.png", id:"startbutton"},
		//{src:"../_images/adbutton.png", id:"adbutton"},
		//{src:"../_images/linkbutton.png", id:"linkbutton"},
		//fr unika flash assets
		{src:"images/title.png", id:"title"},
		
		
		//gemsamm vrig grafik
		//{src:"../_images/birch27italic.png", id:"birch27italic" },
		{src:"../_images/centurygothic16.png", id:"centurygothic16"},
		
		//unik vrig grafik	
		//{src:"images/picquestion01.png", id:"pic01"},
		//{src:"images/picquestion02.png", id:"pic02"},
		//{src:"images/picquestion03.png", id:"pic03"},
		//{src:"images/picquestion04.png", id:"pic04"},
		//{src:"images/picquestion05.png", id:"pic05"},
		//{src:"images/picquestion06.png", id:"pic06"},
		//{src:"images/picquestion07.png", id:"pic07"},
		//{src:"images/picquestion08.png", id:"pic08"},
		//{src:"images/picquestion09.png", id:"pic09"},
		//{src:"images/picquestion10.png", id:"pic10"},
		{src:"images/picquestions.gif", id:"pics"},
		{src:"images/photoquestions.jpg", id:"photos"},
		
		/*----------------------
		 *  _sounds eller sounds
		 * --------------------*/
		//samsung tablet klarar ej dessa (fryser) och mste ha ogg-alternativ? ven om ljud ej laddats s funkar spel (dvs play() falls silently)		
		//{src:"../_sounds/correctanswer.mp3", id:"correctanswer"},
		{src:"../_sounds/Pizzicato01.mp3", id:"correctanswer"},
		//{src:"../_sounds/Do-wing2.mp3", id:"correctanswer"},
		//{src:"../_sounds/Tone4.mp3", id:"correctanswer"},
		{src:"../_sounds/wronganswer.mp3", id:"wronganswer"},
		//{src:"../_sounds/select.mp3", id:"keytap"},
		{src:"../_sounds/Target.mp3", id:"keytap"},
		{src:"../_sounds/welldone.mp3", id:"welldone"},
		{src:"../_sounds/gameover.mp3", id:"gameover"},
		{src:"../_sounds/title.mp3", id:"title"},
		{src:"../_sounds/Woosher7.mp3", id:"woosher"}

	]
    );
    function onProgress(e) {
	
	amask.scaleX = e.progress
	stage.update();
    }
    function onFileLoad(e) {

	counter++;
	//document.getElementById("msg").innerHTML = ""+counter;
	//console.log("file loaded", e.result);
	if (e.item.type == "image") { imgs[e.item.id] = e.result; }
	//sounds registreras automatiskt och r sedan tkomliga via id - createjs.Sound.play(e.id)
	//men bug i chrome tvingar oss att stta pan fr varje ljud
	console.log(e.item.type, e.item.src, e.result)
	if(e.item.type == "sound"){
	    createjs.Sound.setDefaultPlayProps(e.item.src, {pan: 0.0001});
	}
    }
    function onLoadComplete(e) {
//	//we can now access loaded assets (as html-elements) like this: loadQueue.getResult("id-of-asset");
	//console.log(createjs.Sound.activePlugin);
	console.log("font", imgs["centurygothic16"])
	spriteAndFontData();
	


    }
    
    function spriteAndFontData(){
	
	var ssdata;//temporrt objekt fr SpriteSheets skapande

	//var birch27italic_data = {
	//     
	//    //array (one image may not be enough)
	//    //images:[ loadQueue.getResult("birch27italic")],//anvndning av loadQueue mste ske efter preload men vi vill samla data innan/verst...
	//    //images:[ "images/birch27italic.png"],//garanterar inte att bildfil r inladdad innan anvnding...
	//    //images:[ document.getElementById("birch27italic") ],
	//    images:[ imgs["birch27italic"] ],
	//    
	//    //If all grids/frames have the same dimension & regX/Y, a single object is used {width, height, count, regX, regY, spacing, margin}
	//    //margin is margin/border of the whole image. count can be omitted. Indexes to be used in animations are automatically calculated based on position left-right and top-down 
	//    //If grids are differently sized, a 2d-array is used. One array for every grid/frame with the following values:
	//    //[x, y, width, height, imageIndex, regX, regY]. The last three are optional
	//    
	//    //frames:{width:34,height:34},
	//    frames:
	//	[ [0,0,9,22,0,0,0],
	//	 [9,0,8,22,0,0,0],
	//	 [17,0,10,22,0,0,0],
	//	 [27,0,10,22,0,0,0],
	//	 [37,0,10,22,0,0,0],
	//	 [47,0,10,22,0,0,0],
	//	 [0,22,9,22,0,0,0],
	//	 [9,22,9,22,0,0,0],
	//	 [18,22,9,22,0,0,0],
	//	 [27,22,9,22,0,0,0],
	//	 [36,22,4,3,0,0,0],
	//	 [40,22,9,19,0,1,14]],
	//    
	//    //The animation object is optional. A sprite for the sprite sheet can still access frames by gotoAndStop(), gotoAndPlay()
	//    //The custom named properties of the animation object can define animation sequences in several ways (which can be used together):
	//    //1. A single index for non-animated sprites, i.e., dead:15
	//    //2. An array with a start & end frame and the optional string for a following seq. and a number for 'speed' (default 1, 0.5 means show for two timeframes).
	//    //I.e., .takeoff:[1, 8, "fly", 1]
	//    //3. An object with a .frame property for an array for all the frames and optional .next and .speed properties
	//    // I.e. crash:{frames:[1,3,5], next:"dead", speed:[1,0.5,1]}
	//    //If the sprite sheet is to be used for a BitmapText instance, the properties should be named after the characters. I.e., a:65,b:66...
	//    
	//    animations:{ 0:0, 1:1, 2:2, 3:3, 4:4, 5:5, 6:6, 7:7, 8:8, '9':9, '-':10 }
	//};
	//gameData.birch27italic_fontSheet = new createjs.SpriteSheet(birch27italic_data );

	ssdata = {
	//images: [ document.getElementById("centurygothic16") ],
	 images:[ imgs["centurygothic16"] ],
	frames: [
		 [0,0,8,14,0,0,0],[10,0,4,14,0,0,0],[20,0,9,14,0,0,0],[30,0,8,14,0,0,0],[40,0,9,14,0,0,0],[50,0,9,14,0,0,0],[60,0,8,14,0,0,0],[70,0,8,14,0,0,0],[80,0,8,14,0,0,0],[90,0,7,14,0,0,0],[100,0,5,14,0,0,0]	 
		],
	animations:{ 0:0, 1:1, 2:2, 3:3, 4:4, 5:5, 6:6, 7:7, 8:8, '9':9, '-':10 }
	};  
        gameData.timeline_fontSheet = new createjs.SpriteSheet(ssdata);
	
	
	ssdata = {
	    //images: [ document.getElementById("pics") ],
	    images:[ imgs["pics"] ],
	    frames:{width:330,height:160},
	};
	gameData.pics_spriteSheet = new createjs.SpriteSheet(ssdata);
	
	ssdata = {
	    images:[ imgs["photos"] ],
	    frames:{width:330,height:160},
	};
	gameData.photos_spriteSheet = new createjs.SpriteSheet(ssdata);
	
	//finaly
	var id = setInterval( cont, 500);
	function cont(){
	    window.clearInterval(id);
	    

	    
	    stage.removeChild(preloaderText);
	    

	    var credits = new lib.Credits;
	    stage.addChild(credits);
	    credits.x = 0; credits.y = 0;
	    var startButton = new lib.StartButton;
	    stage.addChild(startButton)
	    startButton.x = 270; startButton.y = 310-100;
	    stage.update();
	    startButton.cursor = "pointer"; //requires enableMouseOver()
	    startButton.addEventListener("click", function(){
		stage.removeAllChildren();
		callbackFunction();//skickade som parameter till preload
		
	    }
	    );
	    
	    
	    
	}
    }
    
}