function game(){



window.date = new Date();//global, timeline använder också
date.floatYear = dateToYear(date.getFullYear(), date.getMonth()+1, date.getDate());//.floatYear custom made property
console.log(this);


 
var gameType = "tp"; //bestämmer parametrar. möjliga värden "tp", "edu";

//general vars
var i = 0, j = 0;
var timeoutID; //en "global" - förutsätter att endast en timeout används samtidigt


/*---------------------
   general game vars
-----------------------*/
//var canvas;
window.canvas = {};
//var stage;
window.stage = {};

var loadQueue;

//these three display containers will always be on stage and in this order (bottom first)
//they can all be visible simulataneously if menu bg is transparent
var gameContainer;
    var levelContainer;
var menuContainer;    
var panelContainer;

game.canvas;//just nu används window.canvas men bör ersättas med game.canvas
game.canvasOrigWidth = 0;//sätts nedan
game.canvasOrigHeight = 0;
game.canvasIsFullScreen = false;




//var qData;
var score, orderScore, answerScore/*har bytt namn till precisionScore i createCard*/, levelScore, levelScoreReq, level, numLevels = 5;
var scoreBox;

var timeAtStart, timeAtInputStart, timeAtPrevLoop;

var timeLimit,  timeLeftRatio, timeBonus;


var titleMusic;//stoppas i olika funktioner

//var levelState;//"at_start (innan card flippats klart) "await_answer" (efter flip och innan svar) "evaluate_answer" (efter svar) 

var numErrors;
var numAnswers; //totala antalet svar som gjorts under en hel spelomgång


/*---------------------------
         Hi-scores
 ---------------------------*/
//dom element
var scoreForm = document.getElementById("scoreForm");
scoreForm.style.display = "none";
var inputText = document.getElementById("inputText");

//sparas i localStorage.leaderboard_timelinerome
var leaderboard = [
   // {name:"Anders", score:234, date: new Date },
];

var scoreBoardService;
var globalLeaderboard = [
    
];
var localScoreLowest = 100000000;
var globalScoreLowest = 100000000;


 
/*-------------------    
  genre game vars
---------------------*/
var cursorMarker;
var correctMarker;

//unique game vars
var timeline;
game.timelineDragHasBeenDone = false;

    var tla;
var slider;
var cards = [];
var card;
var picked_indices_at_level

var domcard, domE;

//testPrototypeConcept();

/*------------------------------------------------------
 * Create stage to use already in preloader
 *------------------------------------------------------*/

    //make a global canvas   
    canvas = document.getElementById("canvas1");
    //spara bitmap dimensions om vi skulle ändra framöver.
    //om vi t.ex. skulle dubbla width skulle  den utökade arean vara helt tom om inte grafik i övrigt anpassas
    //vi kan även fylla ut genom stage.scaleX/Y = 2. vilket innebär en kvalitetsförbättring för dynamiskt skapad grafik som text och shapes (men naturligtvis inte för grafik som är baserad på inladdade bitmaps)
    //Ett enklare sätt att åstadkomma detsamma är att sätta canvas.style.width/height till 2*canvas.width/height + "px";
    game.canvasOrigWidth = canvas.width;
    game.canvasOrigHeight = canvas.height;
    
    //nedanstående gör ingen skillnad - måste göra inladdning av fonts här istället för css?
    //var ctx = canvas.getContext('2d')
    //ctx.font = "spirequal_lightregular, League Gothic";

    
   
    canvas.focus();
    stage = new createjs.Stage(canvas);
    //stage = new createjs.StageGL(canvas);//not available i easelJS 0.8.2. (only in easelJSnext on github) It checks if browser supports WebGL, if not, it falls back to canvas2d.
    //webGL innehåller kod direkt för grafikkortet (GPU istället för CPU)
    //Men redan 2015 kom SpriteStage och SpriteContainer som utnyttjar WebGL SpriteStage kan ej innehålla text, shape, container
    
    stage.enableMouseOver(20);//20 är default och anger koll per sekund
   // new createjs.AdHelper(stage).highDPI();
       
    window.canvasIsFullScreen = false;//sätts senare
    
    //om inte touch är enabled väljs hela canvas som ett html-element (färg markeras i min mobil) touch via musklick events funkar fortfarande inom canvas men sker med fördröjning
    //Om allowDefault är true, tillåts document scroll och zoom genom drag och pinch på canvas yta. Om satt till false stängs detta av och möjliggör alltså bl.a. egenprogrammerad drag
    //Men default document scroll och zoom kan vara till glädje genom att t.ex. ta bort Iphone browser interface som annars fastnar och inte kan tas bort om inget annat än canvas visas på skärm
    game.defaultTouchIsAllowed = false;//egenskapad variabel som kan ändras när Touch.enable kallas igen vid screen resize. sätt till true här om timeline pan/zoom ska avaktiveras för icke touch!
    if (createjs.Touch.isSupported()) {//ej nödvändigt att kolla
	createjs.Touch.enable(stage, /*singleTouch=*/ false, /*allowDefault=*/ true);
	game.defaultTouchIsAllowed = true;
	
    }
    //Göra det manuellt
    //Avgör om touch finns genom att kolla om spel startas via touch (ontouchstart event triggas) eller musklick
    //Man kan sen stänga av så att html-elements ej är selectable via: onselectStart = "return false"
    //
    //top.document.getElementById("instructions").innerHTML += "defaultTouchAllowed = " + game.defaultTouchIsAllowed; 
    
/*--------------------------------------------------------*/
var adBlockedAtFirstCheck = -1;
game.setAdBlockDetected = function(){
    if(adBlockedAtFirstCheck == -1){
	adBlockedAtFirstCheck = 1;
	
	var bg = new createjs.Shape();
	drawBg(bg, canvas.width, canvas.height,9);
	stage.addChildAt(bg,0);
	    
	var abw = new lib.Adblockwarning
	stage.addChild(abw);
	abw.x = game.canvasOrigWidth/2;
	abw.y = game.canvasOrigHeight/2;
	//för stage update
	createjs.Ticker.addEventListener('tick', loopGeneral)
	
    }
    
}
game.setAdBlockNotDetected = function(){
    if(adBlockedAtFirstCheck == -1){
	adBlockedAtFirstCheck = 0;
	clearInterval(loadAdIntervalID);
	preload(constructApp);//kalla preload och skicka constrcutApp som callback function
    }
    else
    if(adBlockedAtFirstCheck == 1){
	//adblocker har stängts av - ladda in på nytt
	top.LoadAd.reloadParentWithAds()
    }   
}
//ladda in fake ad från parent window, därifrån kallas setAdBlockDetected och setAdBlockNotDetected

//alternera un-comment av dess två för att stänga av/på adblock detection
var loadAdIntervalID = setInterval(top.LoadAd, 2000);
//preload(constructApp)
    
function constructApp(){
    initData();
    
   createjs.MotionGuidePlugin.install();

    //add methods to createjs 
    createjs.Text.prototype.cacheBounds = function(){

	this.uncache();//annars ger getBounds() senast cachade bitmaps bounds
	var b = this.getBounds()
	if (this.textAlign == "left") {
	    this.cache(0,0,b.width,b.height);
	}
	else if (this.textAlign == "center") {
	    this.cache(-b.width/2,0,b.width,b.height);
	}
	else if (this.textAlign == "right") {
	    this.cache(-b.width,0,b.width,b.height);
	}
    }
    
    createjs.Text.prototype.addHitArea = function(){
	var b = this.getBounds();
	var shape = new createjs.Shape();
	if (this.textAlign == "left") {    
	    shape.graphics.beginFill("#ff0000").drawRect(0,0,b.width,b.height);
	}
	else if (this.textAlign == "center") {
	    shape.graphics.beginFill("#ff0000").drawRect(-b.width/2,0,b.width,b.height);
	}
	else if (this.textAlign == "right") {
	    shape.graphics.beginFill("#ff0000").drawRect(-b.width,0,b.width,b.height);
	}
	this.hitArea = shape;
	
    }
    


    if(top == window)console.log("top = window");

    //vi avkopplar onWindowResize för version med ny css. tanken är att vi istället ska göra en separat full screen version precis som med benchpress
    if(0)//(top.document.getElementById("vertMenu"))//om null så visas spelet antingen utan game container eller i extern sidas game container och i båda fallen ska vi inte använda onWindowResize
    { 
	//if(isScreenSmall()){
	    top.addEventListener("resize", onWindowResize)
	    onWindowResize();//kör direkt för att kolla startläget
	    top.onorientationchange = function(){ 
		//orientationchange innebär resize men ibland har inte skärm/fönster värden hunnit ändras då så vi kör en gång till men fördröjt!
		setTimeout(onWindowResize, 1000);//there may be a delay before width and height properties are set
	    }
	//}
    }
    


    gameContainer = new createjs.Container;
    stage.addChild(gameContainer);
    levelContainer = new createjs.Container;
    gameContainer.addChild(levelContainer);
    
    // create menu graphics (at least a 'Play' button)
    menuContainer = new lib.Menu; 
    stage.addChild(menuContainer);
    bg = new createjs.Shape();
    drawBg(bg, canvas.width, canvas.height, 9);
    menuContainer.addChildAt(bg,0);

    
    //title.png importeras från specifik spelfolder och eftersom dess bredd varierar måste positionen skifta	
    // var title = menuContainer.getChildAt(menuContainer.numChildren-1);
    //title.x = 0.5*( game.canvasOrigWidth-title.getBounds().width );
    
    //Ändrat så att title.omg alltid är 800 px bred (via transparens i Photoshop). title.png ge 0,0 position i Menu MC

   
   menuContainer.adbutton.addEventListener('click', function(){open("http://www.athleticdesign.se")});
   menuContainer.adbutton.cursor = "pointer"; //requires enableMouseOver()
   menuContainer.playbutton.addEventListener('click', constructGame);
   //då playbutton har animerad shine ovanför knappen måste följande TVÅ rader läggas till för att click ska funka 100%
   menuContainer.playbutton.mouseChildren = false;
   menuContainer.playbutton.hitArea = menuContainer.playbutton.getChildAt(0); 
   menuContainer.playbutton.cursor = "pointer"; //requires enableMouseOver() for container or self
   menuContainer.linkbutton.addEventListener('click', function(){open("http://www.athleticdesign.se/educational/index.html")});
   menuContainer.linkbutton.cursor = "pointer"; //requires enableMouseOver() 
   //title.play();
   
    

    //**bitmap test**//
    //bitmap can be preloaded by use in html/css or in javascript with preloadjs
    //createjs.Bitmap() can take either a DOM element or a src string. Either way, the bitmap will be instantly created if it has been preloaded.
    //menuContainer.addChild(new createjs.Bitmap(document.getElementById("front-face")));
    //menuContainer.addChild(new createjs.Bitmap("images/front-face.png"));
    
    //info panels before and after levels 
    panelContainer = new createjs.Container;
    stage.addChild(panelContainer);
    
    //ladda leaderboard array med data från local storage
    //window.localStorage[gameData.sID+"leaderboard"] = "";//clears local leaderboard
    if(window.localStorage[ gameData.sID+"leaderboard" ]){ //dvs den är varken undefined eller tom "" (som den kan vara för vissa private inställningar trots att man har försökt sätta den)
	
	leaderboard = JSON.parse( window.localStorage[ gameData.sID+"leaderboard" ] )
    }
    else leaderboard = [];//överflödigt eftersom leaderboard sattes till tom array i samband med deklaration
    menuContainer.leaderboardLeft.header.text = "Best scores on this computer";
    showLocalLeaderboard();
    
    //init av global leaderboard. GlobalScores ligger i data.js (efterom varje timelien ska ha egna unika fake scores)
    GlobalScores(0);
    menuContainer.leaderboardRight.header.text = "Best global scores last 24 hours";
    showGlobalLeaderboard(gameData.sID);

    //createjs.Ticker.timingMode = createjs.Ticker.RAF;//ignores set framerate and follow screen redraws instead, i.e. only works with timebased animation and flash keyframed animation will be wrong
    createjs.Ticker.timingMode = createjs.Ticker.RAF_SYNCHED;//tries to sync with screen redraws, works best with 60/n framerate
    //createjs.Ticker.timingMode = createjs.Ticker.TIMEOUT;//does not consider screen redraws, more stable framrate than RAF_SYNCHED
    createjs.Ticker.framerate = 60;
    

    //menuContainer.playButton.shape_2.shadow = new createjs.Shadow("rgba(0,0,0,0.5)", 0,5,5);
   createjs.Ticker.addEventListener('tick', loopGeneral)
   
   startMenu();
}

function addToLocalLeaderboard(username, score ){
    
	if( score > localScoreLowest ){
	    var el = {name:username, score:score, date: new Date};
	
	    leaderboard.push(el);
	    leaderboard.sort( function(a,b){return b.score-a.score});  //a-b ger minsta tal först, b-a ger högsta först
	    while(leaderboard.length > 10)leaderboard.pop();
	    
	    //egentligen behövwer vi inte spara i local storage förrän vi lämnar spel/stänger fönster men eftersom vi inte kan veta när det görs sparar vi varje gång score läggs till
	    //(det finns window.onclosed events och liknande men datorn kan ju stängas av direk och ofta refreshar man fönster)
	    
	    window.localStorage[ gameData.sID+"leaderboard"] = JSON.stringify( leaderboard )
	    
	    showLocalLeaderboard();
	}	
}

function showLocalLeaderboard( ){
    
    	//document.getElementById("localLeaderboard").innerHTML = ""
	menuContainer.leaderboardLeft.scores.text = "";
	menuContainer.leaderboardLeft.names.text = "";
	for(var i = 0, l=leaderboard.length; i<l; i++){
	   //document.getElementById("localLeaderboard").innerHTML += ( leaderboard[i].score + "    " + leaderboard[i].name + "<br>" );
	    menuContainer.leaderboardLeft.scores.text +=   leaderboard[i].score + "\n";
	    menuContainer.leaderboardLeft.names.text += i+1 + ". " + leaderboard[i].name + "\n";
	}
	    if(l < 10)localScoreLowest = 0;
	    else localScoreLowest = leaderboard[9].score;
}

function showGlobalLeaderboard(gameName){
  
    menuContainer.leaderboardRight.names.text = GlobalScores.names;  
    menuContainer.leaderboardRight.scores.text = GlobalScores.values;    
}

function loopGeneral(){//är på hela tiden och därmed behövs ingen stageupdate för menu eller game
   stage.update();  
}
/*
function constructMenu(){
    stage.addChild(menuContainer);
    startMenu();
}
*/
function startMenu(){

   //menuContainer.title.play();
   menuContainer.playbutton.play();
   createjs.Sound.stop();//global stop av ljud (så att inte jingel kan blandas med titelmusik)
   titleMusic = createjs.Sound.play("title", {loop:-1});
   
   //start animation
}
//function loopMenu(){
//    console.log("loopMenu")
//     stage.update();  
//}

function stopMenu(){
  
    //menuContainer.playbutton.removeEventListener("click", constructGame);
   
    //menuContainer.title.stop();
    menuContainer.playbutton.stop();
    titleMusic.stop();
}
/*
function destructMenu(){
    stage.removeChild(menuContainer);
}
*/
    
function constructGame(e){
  
    //try fullScreen only if mobile and landscape
//    if(isSmallScreenLandscape()) 
//    {
//	requestFullscreenCanvas();
//    }
    stopMenu();
    menuContainer.visible = false;
    console.log("constructgame")
    
    
    window.questions = [];
    
    //om initData funktion ges olika namn för olika datafiler kan val göras här
//    if(e.currentTarget === menuContainer.anotherplaybutton){
//	gameType = "tp";
//	level = 1;
//	initVideoGamesData();
//    }
    if(e.currentTarget === menuContainer.playbutton){
	gameType = "edu";
	level = 1;
	//initData();
    }
    
    score = 0;
    numAnswers = 0;
    numErrors = 0;
    
    /*--------------------------------------------------------------------------------------
    VÄLJ UT ALLA FRÅGOR/KORT SOM SKA ANVÄNDAS UNDER EN SPELOMGÅNG
    
    (borde göra om hela nedanstående block och använda pools som innehåller questions
    (dvs egentligen referens till questions) istället för index så att koden blir kortare och lättare att förstå)

    /---------------------------------------------------------------------------------------*/
    var i,il,lvl;
    

    //Sortera frågor efter svårighetsgrad (normalt anänds series iställt men för level 1 används df och samverkar med series)
    var index_pools_df = [];//ska innehålla sub/child arrayer
    for(i=0,il=gameData.questions.length; i<il; i++){
	if(gameData.questions[i].df != undefined){
	    df = gameData.questions[i].df;
	    if(index_pools_df[df] == undefined)index_pools_df[df] = [];
	    index_pools_df[df].push(i);
	}
    }
    //lägg till så vi inte har helt tomma element
    for(i=0; i<index_pools_df.length; i++){
	if(index_pools_df[i] == undefined)index_pools_df[i] = [];
    }

    //sortera efter serie
    var j,jl;
    var index_pools_series = [];
    for(i=0,il=gameData.questions.length;i<il;i++){

	if(gameData.questions[i].series != undefined){
	    for(var j=0, jl=gameData.questions[i].series.length; j<jl; j++){
		var si = gameData.questions[i].series[j];
		if(index_pools_series[si] == undefined)index_pools_series[si] = [];
		index_pools_series[si].push(i);

	    }   
	}
    }
    for(j=0;j<index_pools_series.length;j++){
	if(index_pools_series[j] == undefined)index_pools_series[j] = [];
	console.log("num elements in serie " + j+": " + index_pools_series[j].length);
    }
   // 
    
    var numLevels = gameData.cards_at_level.length;//ska iofs alltid vara sex (varav endast fem används)
    
    
    for (lvl=1; lvl<numLevels; lvl++){

	
	//om elementet är en array slumpar vi fram en av dessa subarrayerna och flyttar upp 
	if( typeof( gameData.cards_at_level[lvl][0] ) != "number"){
	    
	    var randInx;
	    
	    //om index inte ska slumpas fram utan vara samma som ett tidigare framslumpat index
	    if( gameData.cards_at_level[lvl][gameData.cards_at_level[lvl].length-1][0] == "s"){
		var lvlInx = gameData.cards_at_level[lvl][gameData.cards_at_level[lvl].length-1][1];
		//gameData.randomLevelIndex array ska redan vara skapad
		randInx = gameData.randomLevelIndex[lvlInx]
		console.log("lvlInx", lvlInx, "randInx", randInx)
	    }
		
	    else randInx = Math.floor( Math.random()*gameData.cards_at_level[lvl].length );
	    
	    gameData.cards_at_level[lvl] = gameData.cards_at_level[lvl][randInx];
	    if(gameData.randomLevelIndex == undefined)gameData.randomLevelIndex = [];
	    gameData.randomLevelIndex[lvl] = randInx;
	    console.log("rndi", lvl, randInx)
	}
    }
    
    //var levelOrder = [0,3,1,2,4,5];//level 3 för rome har unika id - lägg in levelOrder som en gameData variabel!
    
    //bestäm hur många kort varje level ska ha och vilken svårighetsgrad för dessa kort
    //vi vill undvika dubletter både inom och mellan levels
    picked_indices_at_level = [];//ska innehålla sub arrayer
    //gå igenom svårighetsgrad för svårighhetsgrad
    for (lvlo=1; lvlo<numLevels; lvlo++){
	
	var lvl = gameData.levelOrder[lvlo];
	
        if(picked_indices_at_level[lvl] == undefined) picked_indices_at_level[lvl] = [];
     
	for(var n=0, l=gameData.cards_at_level[lvl].length;n<l; n++){

	    var card_type = gameData.cards_at_level[lvl][n];
	    var inx_for_splice = 0;
	    var spliced_element = 0;
	    
	    var pool;
	    //card_type -1 står för difficulty 1, medan 1 står för series 1
	    if(card_type < 0){
		pool = index_pools_df[-card_type];
	    }
	    else pool = index_pools_series[card_type];
	    console.log("cardtype", card_type);
	    if(pool.length == 0){
		console.log("OUT OF CARDS FOR WANTED SERIES!!!!")
		//spliced_element = 0; //visar varningskort 
		pool = index_pools_series[0];
	    }
	    /*
	    if(pool.length == 0){
		console.log("OUT OF CARDS TOTALLY!!!!")
		spliced_element = 0; //visar varningskort 
	    }
	    */
	    else
	    {
		inx_for_splice= Math.floor(Math.random()*pool.length);
		console.log("pool length", pool.length)
		//splice returnerar en array men om endast ett element splicas OCH det är en simple type är det inte nödvändigt att använda [0] som nedan
		spliced_element = pool.splice( inx_for_splice, 1)[0]; //obs! inte ett element från gameData.questions[] utan ett index för gameData.questions[]
		console.log("spliced ele", spliced_element)
		
		//difficulty används endast för level 1 så att vi får en av angiven difficulty och utan att få dubelett med avseende på serie
		if(card_type < 0){
		    //ta bort kort som tillhör samma serie men som finns i andra difficulty pools
		    //OBS! med "samma serie" avser vi den som anges av .series[0] Händelsen kan också tillhöra andra serier men det är bara series[0] som används i level 1
		    for(var df=0; df<index_pools_df.length; df++){
			
			for(var i=0; i<index_pools_df[df].length; i++){
			    if( gameData.questions[index_pools_df[df][i]].series[0] == gameData.questions[spliced_element].series[0] ){
				console.log("remove", df, i, gameData.questions[spliced_element].series[0])
				index_pools_df[df].splice(i,1)
				i--;//kompensera för att element tas bort
			    }
			}
		    }     
		}

		//om så angivit - ta bort alla andra kort med samma år
		if(gameData.allowDuplexYear == false){
		    //ta bort element från övriga serier så att inga dubletter kan fås
		    //går igenom alla serier (även den nyss använda) kort för kort
		    for(j=0;j<index_pools_series.length;j++){
			
			for(i=0;i<index_pools_series[j].length;i++){
			    if( gameData.questions[index_pools_series[j][i]].a == gameData.questions[spliced_element].a)
			    {
				//vi kräver också att intYear har samma värde
				//det innebär att en händelse som i data har givits år -49 kan samexistera med en som har givits -48.5 trots att deras .a värde kommer att vara samma (-48.5)
				//eftersom placering både framför och bakom godkänns trots att .a är samma kommer det inte att innebära spelmekaniska problem
				//orsaken till att detta infördes var för att möjliggöra att frågor med unikt id som ska användas för level med kronologiskt intilligande frågeset
				//även ska kunna förekomma i dublettform (samma händelse men annorlunda formulerad) för användning i tidigare levlar utan att riskera att raderas här
				//att bara låta händelsen kunna komma som fråga på tidigare level och ej ha unikt id kan göra den kronologiska serien splittrad om händelsen inte dyker upp på
				//tidig level (ffa med tanke på att den är en central händelse eftersom den finns på tidig level)
				//optimalt vore att den kronologiska serien skulle kunna anpassas efter vilka händelser som dykt upp tidigare men det kräver massa extra koll
				//men skulle kunna lösas genom att frågorna för kronologisk serie tas fram först - kanske helt enklet genom att ta ut frågor i omvänd levelordning?
				//funkar dock inte bra om sena levlar har satts att ha överblivna frågor (serie 0)!
				
				//if( gameData.questions[index_pools_series[j][i]].intYear == gameData.questions[spliced_element].intYear)
				{
				
				    index_pools_series[j].splice(i,1)
				    i--;//kompensera för att element tas bort
				}
			    }
			}
		    }
		}
		//annars - om så angivet - ta bort kortet även från andra eventuella serier som det tillhör
		else if(gameData.allowDuplexQuestion == false){
		    //mindre tidsödande att kolla elementets .serie array och sedan bara ta bort från de ytterligare serier som kortet tillhör
		    for(j=0;j<gameData.questions[spliced_element].series.length; j++){
			var s = gameData.questions[spliced_element].series[j];
			for(i=0;i<index_pools_series[s].length;i++){
			    if(index_pools_series[s][i] == spliced_element){
				index_pools_series[s].splice(i,1)
				i--;//kompensera för att element tas bort
			    }
			}
		    }
		}
	    }


	    picked_indices_at_level[lvl][l-n-1] = spliced_element;//lägger in dem baklänges (n minskar) eftersom senast skapade kort dras först
	}  
       
    }
    
    //-------------------------------------------------------------------------------------------
    if(gameData.shuffleCards != undefined){
	for(i=1;i<gameData.shuffleCards.length;i++){
	    if(gameData.shuffleCards[i] == true){
		var shuffled = [];
		while(picked_indices_at_level[i].length > 0){
		    var inx = Math.floor(Math.random()*picked_indices_at_level[i].length);
		    shuffled.push(picked_indices_at_level[i].splice(inx,1));
		}
		picked_indices_at_level[i] = shuffled;
	    }
	}
    }

    createGameGraphics()
    constructLevel()
}

function constructLevel(){
    
    //alert(getDimensions())
    
    createLevelGraphics();
    
    levelScore = 0;
	
    reqLevelScore = cards.length * gameData.reqCardScore[level];
    timeLimit = gameData.timeLimit[level]; //om <= 1000 sätts den först senare när nytt kort dras

    scoreBox.updateScore();//scoreBox skapas i createLevelGraphics
   
    //Autostart 
    if(level == 0)startLevel();
    
    //Start via startLevelPanel. This 'panel' may differ from level to level and...
    //...may contain instructions, some kind of presentaion or animation, or mereley a button 
    if(level == 1)panelContainer.panel = createPanel("WELCOME!");
    else if(level > 1)panelContainer.panel = createPanel("WELL DONE!");
    

    panelContainer.addChild(panelContainer.panel);
    panelContainer.panel.alpha = 0;
    createjs.Tween.get(panelContainer.panel).to( {alpha:1}, 1000 ).call(function(){
	 panelContainer.panel.continueButton.addEventListener('click', startLevel);
    }); 
   
    stage.update();
    
}
  
function startLevel(e){//input and time
    
    
    panelContainer.panel.continueButton.removeEventListener('click', startLevel);
    panelContainer.removeAllChildren();
    
    inputChainGame();//sets inputHandler that handles logic and rendering (i.e. modify display list) and finaly sets another inputHandler and so on 
        
    //start time (setInterval is an alternative)
    createjs.Ticker.addEventListener('tick', loopGame);//if inputChain is large, loop may only check time
 
}
    
//function inputGame(e){
    //e.target = original target of click (i.e. the deepest (explains term 'event bubbling') in the display hierarchy, but highest in the overlay drawing stack)
    //the target may not have been set up to dispatch an event to a handler/listener (i.e.,through addEventListener())
    //e.currentTarget = this = the eventdispatcher of this handler (may be the orignal target or a display object that contains the target
    //i.e., e.currentTarget = "currentContainerOfTarget"
    
    
   
//}


function loopGame(e){
 //detta är level/game loop som startar efter man tryckt startknappen
 //kan tänka sig en loop för allt och använda statevillkor inom loopen
 //if state == menu
 //if state == game_instructions
 //if state == level_waiting_for_card_flip
 //if state == level_waiting_for_answer
 //if state == level_eval_answeer
 //if state == game_over
 // etc
 
 
    //console.log(e.delta);//tide sedan senaste loop. Nedan används dt som mer generell delta mellan t.ex. nuvarande tid och start av valfri händelse
    //console.log(createjs.Ticker.getTime(false/true));//time since first listener was added or since Ticker.init() was called, if called with true, only time while Ticker.paused == false will be returned
    //console.log(createjs.Ticker.getMeasuredFPS());
    //console.log(createjs.Ticker.getMeasuredTickTime());
    
    var time = createjs.Ticker.getTime();
    var dt, ratio;//generic for several uses
    
    ratio = 1; //för time left och därmed för timeleftbar och score 
    
    //if timeline is waiting for click
    if(timeLimit == 0)ratio = 0;
    else if( timeline.hasEventListener("answer")){
	//beräkna hur mycket timeleft
	dt = time-timeAtInputStart;
	ratio = 1-(dt/timeLimit);//timeLimit global i ms och sätts för varje level
	
	if(ratio < 0){
	    ratio = 0;
	    //auto answer when time is up
	//    if(timeline.manualAnswer !== false){//check så att vi bara dispatchar en gång (sätts till undefined och sedan till true/false. undefined och false är båda "falsy" men de är ej ==)
	//	timeline.manualAnswer = false;
	//	timeline.dispatchEvent("answer");
	//    }
	}
	card.timeBar.set(ratio)
    }
    timeLeftRatio = ratio;
    
    /*
    if(gameData.sID == "timeline-birthusa"){
	pan += 0.01;
	gameContainer.getChildAt(0).scroll(pan);
    }
    */
 
}
    var pan = 0;
function stopLevel(desc){
    
    //stop input
    
    //stop loop
    createjs.Ticker.removeEventListener("tick", loopGame);
   
    if(desc == "WELL DONE!"){
	constructLevel();//skippa att visa panel då kommande startpanel visar tillräcklig info
//      panelContainer.panel = createPanel(desc);
//	panelContainer.addChild(panelContainer.panel);
//	panelContainer.panel.continueButton.addEventListener('click', toNextLevel);
    }
    else{
	panelContainer.panel = createPanel(desc);
	panelContainer.addChild(panelContainer.panel);
	
	//är score tillräckligt hög för att vi sak be om namn och belasta API
	if(score > localScoreLowest || score > globalScoreLowest){

	    //visa html element för input av text

	    scoreForm.style.display = "block";
	    //inputText.focus();
	    var style = canvas.currentStyle || getComputedStyle(canvas, null);
	    var cw = parseInt( style.width, 10 );
	    var ch = parseInt( style.height, 10 );
	    style = scoreForm.currentStyle || getComputedStyle(scoreForm, null);
	    var sfw = parseInt( style.width, 10 );
	    var sfh = parseInt( style.height, 10 );
	    
	    //CSS har satt: position = "absolute" top = 0 left = 0
	    //createjs DOMElement använder CSS transform för x, y, scaleX, vilka är bekvämare att koda och vi skapar därför DOMElement 
	    //har annars ingen direkt nytta av att använda DOMElement eftersom skalning av canvas inte medför skalning av scoreForm 
	    var de = new createjs.DOMElement(scoreForm);
	    panelContainer.addChild(de)
	    de.x = 0.5*(cw-sfw);
	    de.y = 0.4*(ch-sfh);
	    
	    //OBS! Om canvas resize gör kommer inte scoreform att hamna rätt men detta kan så klart korrigeras i onresize funktionen
	 
	}
	//en html elemment listener så att enter/return tar en vidare direkt
	scoreForm.onsubmit = function(e){
	    e.preventDefault();
	    toMenu();
	}

	panelContainer.panel.continueButton.addEventListener('click', toMenu);
	panelContainer.panel.continueButton.cursor = "pointer"; //requires enableMouseOver()
    }

    function toNextLevel(){
        panelContainer.panel.continueButton.removeEventListener("click", toNextLevel);
        panelContainer.removeAllChildren();
        constructLevel();
    }
    function toMenu(){
	
	//la in detta för att hindra att masks mouseover triggas på menuskärm (trots att timeline ej syns)
	//bör väl strukturera annorlunda/bättre med en specifik clean-up funktion
	gameContainer.removeAllChildren();
	timeline = null;
	
	//score
	var username = inputText.value;
	if(username == "")username = "Anonymous"
	scoreForm.style.display = "none";
	
	addToLocalLeaderboard(username, score);
	
	//GlobalScores ligger i data.js (efterom varje timelien ska ha egna unika fake scores)
	GlobalScores.saveScores(0, username, score);
	showGlobalLeaderboard(gameData.sID);
	


        panelContainer.panel.continueButton.removeEventListener("click", toMenu);
        panelContainer.removeAllChildren();
        menuContainer.visible = true;
	startMenu();
	//cancelFullscreenCanvas();
    }

}

//function getPerl(){
//    
//    var xhr = new XMLHttpRequest();
//    xhr.onreadystatechange = function(){
//	if(xhr.readyState == 4 && xhr.status == 200){
//	    console.log(xhr.responseText);
//	}
//    }
//    xhr.open("GET", "http://www.athleticdesign.se/cgi-bin/getScores-all.pl", true);
//    xhr.send();
//}




//function destructLevel(){
//    gameContainer.removeAllChildren()
//}
    
       
   
/*-----------------------------   
Game specific helper functions
-------------------------------*/
 
   

    
function createMenu(){

}

//function createStartLevelPanel(){
//    var panel = new lib.Panel();
//    //panel.tF0.text = "INSTRUCTIONS";
//    //panel.tF1.text = "Instructions:";
//    panel.w = 700; panel.h = 300; //check dimensions in flash
//    //panel.regX = panel.w/2;
//    panel.regY = panel.h/2;
//    panel.x = canvasOrigWidth/2; panel.y = canvasOrigHeight/2;
//    panel.continueButton.cursor = "pointer";
//    return panel;
//}
    
function createPanel(desc){
    var panel = new lib.Panel();
    
    if(desc == "WELCOME!")panel.header.gotoAndStop(0);
    else if(desc == "WELL DONE!")panel.header.gotoAndStop(1);
    else if(desc == "GAME OVER")panel.header.gotoAndStop(2);
    else if(desc == "GAME WON!")panel.header.gotoAndStop(3);
    else if(desc == "WRONG ORDER")panel.header.gotoAndStop(4);
    else if(desc == "LEVEL COMPLETED!")panel.header.gotoAndStop(4);

    
    if(desc == "WELCOME!")panel.tF1.text = "Your current rank is:";
    else if(desc == "WELL DONE!")panel.tF1.text = "Your new rank is:";
    else if(desc == "GAME OVER")panel.tF1.text = "Your final rank is:";
    else if(desc == "GAME WON!")panel.tF1.text = "Your rank is:";
    else if(desc == "WRONG ORDER")panel.tF1.text = "Your final rank is:";
    else if(desc == "LEVEL COMPLETED!")panel.tF1.text = "Your new rank is:";
    
    var rank = level-1;
    panel.rank.gotoAndStop(rank)
    if(desc == "GAME OVER"){
	panel.rank.gotoAndStop(6+rank)

    }
    

    if(desc == "WELCOME!" || desc == "WELL DONE!" || desc == "LEVEL COMPLETED!"){
	panel.tF2.text = gameData.getRequirementTextForLevel(level, game.defaultTouchIsAllowed);
	panel.tF2.alpha = 0;
	panel.tF2.scaleY = 1;
	panel.tF2.scaleX = 1;
	panel.tF2.y += panel.tF2.regY += panel.tF2.getBounds().height/2;
	//panel.tF2.x += panel.tF2.regX += panel.tF2.getBounds().width/2;
	
	createjs.Tween.get(panel.tF2).wait(1000).to( {alpha:1, scaleY:1, scaleX:1}, 4000, createjs.Ease.cubicOut )//.call(onOrderScoreComplete)
    }
    else panel.tF2.text = "";
    
    if(desc == "WELCOME!" || desc == "WELL DONE!" || desc == "LEVEL COMPLETED!")panel.continueButton.gotoAndStop(0);
    else panel.continueButton.gotoAndStop(1);
    
    panel.w = 700; panel.h = 300; //check dimensions in flash
    //panel.regX = panel.w/2;
    panel.regY = panel.h/2;
    panel.x = game.canvasOrigWidth/2;
    panel.y = game.canvasOrigHeight/2-50;
    
 
    panel.continueButton.cursor = "pointer";
    return panel;
}

function createGameGraphics(){//den grafik som inte behöver skapas på nytt;
    var i,j;
    
    gameContainer.removeAllChildren();
    
    var bg = new createjs.Shape();
    drawBg(bg, canvas.width, canvas.height, 8);
    gameContainer.addChildAt(bg,0);
    
    scoreBox = createScoreBox();
    scoreBox.x = 805;scoreBox.y = 0;
    gameContainer.addChild(scoreBox);
    
    //timeline  

    timeline = createTLA(date.floatYear, 0.95, gameData.timeline_fontSheet);
    //inhämta samma timeline settings som används för level 1
   
    var tlo = gameData.initTimeline(timeline);//sätter timelines zoom och pan. deras initvärden är olika från spel till spel
    
    //sätt direkt fixedYear/position, scale sätts alltid via slider
    timeline.fixedYear = tlo.fixedYear; timeline.fixedPosition = tlo.fixedPosition;
    
    gameContainer.addChild(timeline);
     
    timeline.x = game.canvasOrigWidth/2;
    timeline.y = game.canvasOrigHeight - 105;
    
    //istället för eventdispatch använder vi enklare, egengjord variant)
    timeline.callbackFunctionForSet = onTimelineSet;
    function onTimelineSet(o){
	gameContainer.getChildAt(0)/*bg*/.scroll( 0.0005*timeline.scale*o.dYear, undefined, 0.1*o.dScale );
	return;
	
    }
    
    
    var timelineBaloon;
    timeline.maskedContainer.on('mouseover', function(e){	

	if(level > 1 && game.timelineDragHasBeenDone == false && game.defaultTouchIsAllowed == false && timeline.hasEventListener("answer") != true){
	    stage.removeChild(timelineBaloon);//för säkerhetsskull - ger ej error om child ej finns 
	    var ts = "You can explore the timeline!\n\nDrag sideways to move.\nDrag up-down to zoom."
	    timelineBaloon = createBaloonHelp(ts, {lineWidth:190}, {arrowH:8, arrowDir:"south"}, undefined/*vi bifogar ej target och behöver därför lägga till displaylist manuellt*/
					 , e.stageX/*vi skickar globala koordinater så att justering av grafik kan göras*/, timeline.y-10);//
	    stage.addChild(timelineBaloon);
	    timelineBaloon.x = e.stageX//e.localX;//vi sätter till lokal koordinat som motsvarar skickade global (obs dock att local tillhör maskedcontainer och inte timeline som är egentlig displayparent men de har båda gemensamt koord.system)
	    timelineBaloon.y = timeline.y-10;//e.stageY-10//e.localY;
	    
	    timelineBaloon.scaleUp(200);
	}

//    //stage.on("click", function (e){//för mobiler (här stage click men vanligt är också att click på själva tooltip krävs)
//    card.label1.on("mouseout", function (e){
//	card.removeChild(card.baloon_1, false)
//    });
    });
    timeline.addEventListener("drag1sttime", function(e){
	stage.removeChild(timelineBaloon);//om specificerad child ej finns på displaychild händer inget annat än att false returneras
    });
    timeline.maskedContainer.on('mouseout', function(e){

	stage.removeChild(timelineBaloon);//om specificerad child ej finns på displaychild händer inget annat än att false returneras

    });

	

	    
	//labels
	
	timeline.removeDefEvents();
	
	timeline.defEvents[0] = {d:"Today", a:date.floatYear, month:date.getMonth()+1, day:date.getDate()};
	for(i=1;i<=gameData.numObligatoryMilestones;i++) timeline.defEvents.push( gameData.questions[i] );//lägg till milestones: index 1 - gameData.numObligatoryMilestones
	//lägg till en milestone som är närliggande ämnet för spelet
	if( gameData.additionalMilestones > 0 ){
	    timeline.defEvents.push( gameData.questions[ gameData.numObligatoryMilestones + 1 + Math.floor(Math.random()* gameData.additionalMilestones )  ] );
	}
 
    

    slider = createVSlider(0,200, 2*timeline.maxScale, timeline.minScale, "x");
    gameContainer.addChild(slider);
    slider.x = 40;
    slider.y = timeline.y - slider.maxPos +10;

    //evenhandler utanför slider och timeline objekt så att de inte är beroende av varandra
    slider.addEventListener("change", function(e){
        //var sl = e.currentTarget;//onödigt eftersom vi vet att det är slider
	//timeline.scale = sl.getValue();
	
	timeline.scale = slider.getValue();
        timeline.drawTimeline();

    });
   slider.setPositionByValue(tlo.scale);//will activate eventlistener above
   slider.visible = false;
}
function createLevelGraphics(){
    
    levelContainer.removeAllChildren();
    gameContainer.addChildAt(levelContainer, gameContainer.numChildren)
  
    //cards
    
    card = null;//will be drawn at pickandflip() from  the card array created below
    cards = [];

    for(var i=0, il=picked_indices_at_level[level].length; i<il; i++){
	
	var new_card = createCard( gameData.questions[ picked_indices_at_level[ level ][i] ] );
	//var new_card = createCard( gameData.picked_questions_at_level[level][i] );
	cards.push(new_card)
	//container for scaling so that we later can use a separate scaleX for flipping animation
	var scaleContainer = new createjs.Container();
	scaleContainer.addChild(new_card);
	levelContainer.addChild(scaleContainer);
	
	scaleContainer.scaleX = scaleContainer.scaleY = 0.7;
	//place in heap at topleft corner
	//offset with half width & height as origo is centered
	var n = cards.length;
	new_card.x = 2-n*2 + new_card.w/2; new_card.y = 2-n*2 + new_card.h/2;
    }
}

 //**CARD CLICKED**//
    function inputChainGame(){
	
         //pick
        card = cards.pop();
	
	if( gameData.timeLimit[level] <= 1000) timeLimit = card.question.q.length*gameData.timeLimit[level];
	else timeLimit = gameData.timeLimit[level];
	
	if(timeLimit == 0)card.hideTime();
	
	if( game.defaultTouchIsAllowed == false && gameData.manualPan[level])timeLimit *= gameData.manualPan[level];
        
        //card.uncache();
        //TWEEN FLIP OF CARD
	var tweentime = 750;
	createjs.Sound.play("woosher", {volume:0.1})
        createjs.Tween.get(card).to({scaleX:0, rotation:45}, tweentime/2).call(function(){card.gotoAndStop(1)}).to({scaleX:1, scaleY:1, rotation:0}, tweentime/2);
        createjs.Tween.get(card.parent).to({scaleX:1, scaleY:1}, tweentime);
        createjs.Tween.get(card).to({x:game.canvasOrigWidth/2, y:game.canvasOrigHeight/3-10}, tweentime).call(onFlipComplete);
	
        function onFlipComplete(){
            //card.cache(-card.w/2,-card.h/2,card.w, card.h)
        }
	
    //ta reda på vilka markörer och labels som ska finnas på timeline
    var i,il,df;
    
    //Sortera frågor efter svårighetsgrad (vanliga frågor använder inte längre .df utan endast .series men labels gör det)
//    var index_pools = [];//ska innehålla sub/child arrayer
//    for(i=0,il=gameData.questions.length;i<il;i++){
//	if(gameData.questions[i].df != undefined){
//	    df = gameData.questions[i].df;
//	    if(index_pools[df] == undefined)index_pools[df] = [];
//	    index_pools[df].push(i);
//	}
//    }
    
    //sortera efter serie så att vi kan använda "same_series"
    var j,jl,si;
    var index_pools_series = [];
    for(i=0,il=gameData.questions.length;i<il;i++){
	if(gameData.questions[i].series != undefined){
	    for(j=0, jl=gameData.questions[i].series.length; j<jl; j++){
		si = gameData.questions[i].series[j];
		if(index_pools_series[si] == undefined)index_pools_series[si] = [];
		index_pools_series[si].push(i);

	    }   
	}
    }
    
    var  num_cards_taken = gameData.cards_at_level[level].length - cards.length;
    var card_type = gameData.cards_at_level[level][ num_cards_taken-1 ];
    var mal = gameData.milestones_at_level[level][ num_cards_taken-1 ];

    
    if(mal == "init"){
	
	timeline.removeDefEvents();

    }
    else if(mal == "keep" || mal == undefined){
	;
    }
    else if(mal == "clear"){

	timeline.removeDefEvents();
    }
    else if(mal == "all"){
	
	timeline.removeDefEvents();

	timeline.defEvents[0] = {d:"Today", a:date.floatYear, month:date.getMonth()+1, day:date.getDate()};
	for(i=1;i<=gameData.numObligatoryMilestones;i++) timeline.defEvents.push( gameData.questions[i] );//lägg till milestones: index 1 - gameData.numObligatoryMilestones

    }
    else if(mal == "same_series"){

	timeline.removeDefEvents();
	for (i=0,il=index_pools_series[card_type].length; i<il;i++) {
	    var qn = gameData.questions[ index_pools_series[card_type][i] ]
	    if( card.question == qn);
	    else timeline.defEvents.push ( qn );
	}

    }
	
	    
        //SLUMPA FRAM HUR NY TIMELINE SOM RYMMER EFTERFRÅGAT ÅR SKA SE UT
	
	slider.visible = false;
	
	    timeline.cursorLine.visible = false;
	    timeline.spanMarker.visible = false;
	
	//spara startvärdem
	var cur_scale = timeline.scale;
	var cur_log = Math.log(timeline.scale)/Math.LN10;
	var cur_year = timeline.fixedYear;
	var cur_pos = timeline.fixedPosition;
	
	
	//hämta timeline utseende via wrapper function i för varje spel separat datafil
	//objektet tlo som returneras gör det möjligt för oss att tweena till önskat timeline utseende
	var  tlo = gameData.timelineForYearLevelNumAnswers(timeline, card.question.a, level, numAnswers, game.defaultTouchIsAllowed);
	
	var new_log = Math.log(tlo.scale)/Math.LN10;
	
	var scaleDist = Math.abs( new_log - cur_log );
	var scaleTime = 2000*Math.sqrt(scaleDist);
	if(scaleTime > 9000)scaleTime = 9000;
	
	//tweena scale och pan/scroll var för sig. 
	var cur_left_year, left_year, panTime, panDist;

	if(timeline.scale < tlo.scale){//panna först, zooma in därefter
	    
	    //vi måste utgå från samma position, t.ex. vänstra kant, för att vi ska kunna ta fram hur mycket timeline ska scrolla/panna
	    cur_left_year = timeline.getYear(0);
	    //sätt temporärt timeline till framtagna nya tlo värden så att vi kan använda timeline methods för att ta fram nya left year
	    timeline.fixedYear = tlo.fixedYear;
	    timeline.fixedPosition = tlo.fixedPosition;
	    left_year = timeline.getYear(0);
	    
	    panDist = Math.abs( timeline.scale*(left_year - cur_left_year) );
	     
	     
	}
	else{//zooma ut först, panna därefter
	    
	    //sätt temporärt timeline till framtagna nya tlo värden så att vi kan använda timeline methods för att ta fram left year
	    timeline.scale = tlo.scale;
	    cur_left_year = timeline.getYear(0);//dvs left year efter första zoom
	    
	    timeline.fixedYear = tlo.fixedYear;
	    timeline.fixedPosition = tlo.fixedPosition;
	    left_year = timeline.getYear(0);
	    
	    panDist = Math.abs( tlo.scale*(left_year - cur_left_year) );
	}
	//återställ timeline värde
	timeline.scale = cur_scale;
	timeline.fixedYear = cur_year;
	timeline.fixedPosition = cur_pos;
	
   
	var panTime = 60*Math.sqrt(panDist)//1000*panDist/800;
	if(panTime > 9000)panTime = 9000;
	console.log("pantime", panTime)
	
	
	//TWEENA VÄRDEN FÖR SLIDER OCH TIMELINE
	var proxyObj = {log:cur_log, year:cur_year, pos:cur_pos};
	

	var ease = createjs.Ease.quadInOut;
	
	//zooma in - börja med pan
	if(timeline.scale < tlo.scale){
	     createjs.Tween.get(proxyObj).
	     to( {year:tlo.fixedYear, pos:tlo.fixedPosition }, panTime, ease ).
	     to( {log:new_log}, scaleTime, ease ).call(onTweenComplete).
	     addEventListener("change", handleChange);//call returns tween obj but addEventListener returns handler function 
    
	}
	//börja med scale
	else{
	    createjs.Tween.get(proxyObj).
	    to( {log:new_log}, scaleTime, ease ).
	    to( {year:tlo.fixedYear, pos:tlo.fixedPosition}, panTime, ease).
	    call(onTweenComplete).
	    addEventListener("change", handleChange);//call returns tween obj but addEventListener returns handler function 

	}
	
	

	//createjs.Tween.get(proxyObj).to( {ratio:new_ratio, year:new_year, pos:new_pos }, tweentime ).call(onTweenComplete).addEventListener("change", handleChange);//call returns tween obj but addEventListener returns handler function
	function  handleChange(e) {
	    /*-----------------------------------------------------------------------------------------------------------------
	    e = eventobject, e.target = objektet som dispatchar event ("tween objektet"), e.target.target = objektet som tweenas
	    ------------------------------------------------------------------------------------------------------------------*/
	    //console.log("log", proxyObj.log, "year", proxyObj.year);
	    /*
	    timeline.fixedYear = proxyObj.year;
	    timeline.fixedPosition = proxyObj.pos;
	    timeline.scale = Math.pow(10, proxyObj.log);
	    */
	    
	    timeline.setTimeline(proxyObj.pos, proxyObj.year, Math.pow(10, proxyObj.log), "current" );
	    timeline.drawTimeline();
	    	
	}
	


        //start timeline input
        function onTweenComplete(tween){
	    /*-----------------------------------------------------------------------------------------------------------------
	     tween = "tween objektet"/instans av Tween klass, tween.target = objektet som tweenas
	    ------------------------------------------------------------------------------------------------------------------*/
	    //gör alltid om maxdevpixels till maxdevyears så att det funkar även om man skalar
	    if(gameData.maxDevPixels != undefined) gameData.maxDevYears = gameData.maxDevPixels/timeline.scale;
	    
	    timeline.addEventListener('answer', evaluateAnswer);  
	    timeline.manualAnswer = undefined;//sätts sedan till true vid mus pressup på timeline eller till false om tid går ut
	    timeAtInputStart = createjs.Ticker.getTime();
            //timeline.cursor = 'pointer'; //"none"
	    timeline.intYearCursor = card.question.intYear;
	    timeline.cursorLine.visible = true;
	    timeline.spanMarker.visible = true;

        }
    }
    
    //**TIMELINE CLICKED**// Obs att det först exekveras kod i createTLA's onPressUp där också dispatch av "answer" sker 
    function evaluateAnswer(e){
	
	//slider.visible = true;
	
        //stop timeline input
        timeline.removeEventListener('answer', evaluateAnswer);  //timeline kan fortsätta dispatcha vid presssup men vi lysnar inte längre
	//muspekares x finns lagrat i tl.cursorLine.x och kommer inte att ändras nu när vi har tagit bort eventListener

	/*-----------------------------------
	 vald x - vi använder local alias
	-----------------------------------*/
	//var chosen_x = timeline.cursorLine.x;
	
	/*-----------------------------------
	 korrekt x - ingen avrudning
	-----------------------------------*/
	var correct_x = timeline.getPixelExact(card.question.a);
	
	/*--------------------------------------------
	 valt år - ingen avrundning
	---------------------------------------------*/
	var chosen_year = timeline.cursorYear;
	
	/*-----------------------------------
	 korrekt år - vi har card.question.a
	-----------------------------------*/
	var correct_year = card.question.a
	
	
	/*----------------------
	 Beräkna Score
	-----------------------*/
	orderScore = 0;
	answerScore = 0;
	timeBonus = 0;

	//if auto answer when time is up
	if(timeline.manualAnswer === null){
	    
	    //createjs.Sound.play("wronganswer");//play error sound
	    chosen_year = correct_year;
	    onTweenComplete();
	}
	else{
	    
	    numAnswers++;
	    
	    
	    /*Order Score
	    --------------*/
	    checkOrder:
	    {
		//vi kan inte använda .visibelEvents eftersom intilliggande markör kan ligga utanför skärm (om man flyttar och zoomar själv)
		//Leta efter markör som ligger mellan tryckt postion och korrekt position - om sådan finns har valt fel intervall
		if(chosen_year < correct_year){
		    for(var i=0, l=timeline.defEvents.length;i<l;i++){
			if(timeline.defEvents[i].a > chosen_year && timeline.defEvents[i].a < correct_year) break checkOrder;
		    }

		}
		else if(chosen_year > correct_year){
		    for(var i=0, l=timeline.defEvents.length;i<l;i++){
			if(timeline.defEvents[i].a < chosen_year && timeline.defEvents[i].a > correct_year) break checkOrder;
		    }
		}
		orderScore = 100;//förblir alltså 0 om break verkställs
	    }
	    if(orderScore == 0){
		numErrors++;
		createjs.Sound.play("wronganswer");//console.log("WRONG ORDER")
		scoreBox.updateScore(score);//synliggör checks
		var check = scoreBox["check"+numErrors]
		check.scaleX = check.scaleY = 5;
		//createjs.Tween.get(check).wait(0).to( {scaleY:1, scaleX:1}, 1000, createjs.Ease.bounceOut )//.call(onOrderScoreComplete)
		createjs.Tween.get(check).wait(0).to( {scaleY:1, scaleX:1}, 1400, createjs.Ease.elasticOut )//.call(onOrderScoreComplete)
	    }
	    else createjs.Sound.play("correctanswer", {volume:0.01})

	    /*Precision Score (answerScore)
	    -----------------------------*/

	/***ÄNDRAT SÅ ATT MAXDEVYEARS ALLTID ANVÄNDS: MAXDEVPIXELS OMVANDLAS EFTER TIMELINES "DEFAULT SKALA" FÖR FRÅGAN. PÅ SÅ SÄTT FUNKAR DET ÄVEN OM SKALA DÄREFTER ÄNDRAS***/
	    //om poäng ska beräknas pixelavstånd
	//    if(gameData.maxDevYears === undefined){
	//	var dev = Math.abs(correct_x-chosen_x);
	//	if(dev >= gameData.maxDevPixels)answerScore = 0;
	//	else answerScore = (1-(dev/gameData.maxDevPixels))*gameData.answerScoreMax;
	//    }
	    //om poäng ska beräknas på årsavvikelse
	    //else if(gameData.maxDevPixels === undefined)
	    {
		var dev = Math.abs( correct_year - chosen_year );
		if(dev >= gameData.maxDevYears)answerScore = 0;
		else answerScore = (1-(dev/gameData.maxDevYears))*gameData.answerScoreMax;
	    }
	    answerScore = Math.round(answerScore);
	    
	    
	    /*Time Score (timeBonus)
	    -----------------------------*/
	    timeBonus = Math.round(100*timeLeftRatio);
	    
	    levelScore += (orderScore+answerScore+timeBonus);
	    score += (orderScore+answerScore+timeBonus);
	    //visa score först efter cursormarker har tweenat klart
	    
	    

	    /*Visa correctMarker
	    --------------------------------------------*/
	    timeline.correctMarker.visible = true;
	    timeline.correctMarker.alpha = 1;
	    timeline.correctMarker.setYear(card.question.a, card.question.isIntYear, card.question.isCirca, card.question.day);
	    timeline.correctMarker.position();
	    timeline.drawSpan(timeline.correctMarker.x);

	    time = 250;
	    /*-----------------------------------------------------
	    //klumpigt men bekvämt sätt att blinka ett fixt antal ggr
	    --------------------------------------------------------*/
	    createjs.Tween.get(timeline.correctMarker ).
	    to( {visible:false }, time ).
	    to( {visible:true }, time ).
	    to( {visible:false }, time ).
	    to( {visible:true }, time ).
	    call(onTweenComplete);
	    
	    //för att istället blinka tills händelse/input
	    //createjs.Tween.get(timeline.correctMarker, {loop:true}).to( {visible:false }, time ).to( {visible:true }, time )
	    //och createjs.Tween.removeTweens(timeline.correctMarker) när händelse inträffar
	    
	    //Ett annat (bästa?) sätt: id = setInterval(function, time) & clearInterval(id)
	    
	    //kan även göra all blinkning i mainloop genom att stoppa displayobject i global array binkingObjects
	    //och använda properties som .blinkInterval (antal frames mellan skifte) och .blinkDuration (antal frames)
	    //för att stoppa blinkning vid händelse tas objektet bort från array
	}
	
	function  handleChange(e){ //användes innan när vi tweenade från tryckt position till korrekt position
	    /*-----------------------------------------------------------------------------------------------------------------
	    e = eventobject, e.target = objektet som dispatchar event ("tween objektet"), e.target.target = objektet som tweenas
	    jfr med call(onTweenComplete)
	    ------------------------------------------------------------------------------------------------------------------*/

	   // timeline.correctMarker.setYear(Math.round(proxyObj.year));
	    timeline.correctMarker.setYear(proxyObj.year);
	    timeline.correctMarker.position();
	    //slutliga ritning gjordes i grön färg i onTweenComplete
	    if(proxyObj.year != proxyObj.endYear)timeline.drawSpan(timeline.correctMarker.x, "rgba(150,0,0,0.5)");
	}
  
	function onTweenComplete(tween){ 
	    /*-----------------------------------------------------------------------------------------------------------------
	     tween = "tween objektet"/instans av Tween klass, tween.target = objektet som tweenas
	    jfr med addEventListener("change", handleChange)
	    ------------------------------------------------------------------------------------------------------------------*/
	    
	    //handleChange aktiveras efter onTweenComplete men vi vill inte köra hela handleChange efter onTweetComplete
	    //och avaktiverar den..
	    //tween.removeEventListener("change", handleChange);
	    //////...men kör därefter en del av dess kod
	    //timeline.correctMarker.setYear(proxyObj.year);
	    //timeline.correctMarker.position();
	    //Vi löser det istället genom att jämföra endYear med year i handleChange!
	    
	    //if(gameData.useMilestones)timeline.defEvents.push(card.question);
	    
	    /*Visa poäng och tillhörande ljud & grafik
	    ------------------------------------------*/
	    
	    //rita grönt (default färg) span (istället för rött som i handleChange).
	    //Rita innan milestones har lagts till så att den inte påverkar span!
	    //timeline.drawSpan(timeline.correctMarker.x);
	    
	    //timeline.drawInd();
	    //timeline.ind.x = correct_x;
	    
	    
	    if(gameData.useMilestones)timeline.defEvents.push(card.question);
	    timeline.drawInd(gameData.maxDevYears);
	    timeline.ind.x = correct_x;
	    
	    var star = new lib.StarRotaterScalerUpDown();
	    card.addChild(star);
	    star.alpha = 0;
	    card.updateScore(orderScore);
	    if(orderScore == 0)onOrderScoreComplete()
	    else{
		star.alpha = 1;
		star.x = -62, star.y = 77;
		createjs.Tween.get(star).wait(0).to( {alpha:0, y:27 }, 500, createjs.Ease.linear ).call(onOrderScoreComplete)
		createjs.Sound.play("keytap", {volume:0.02})
	    }

	    function onOrderScoreComplete(tw){
		
		card.updateScore(orderScore, answerScore);
		if(answerScore == 0)onAnswerScoreComplete();
		else{
		    star.alpha = 1;
		    star.x = 20, star.y = 77;
		    createjs.Tween.get(star).wait(0).to( {alpha:0, y:27 }, 500, createjs.Ease.linear ).call(onAnswerScoreComplete)
		    createjs.Sound.play("keytap", {volume:0.02})
		}
		
	    }
	    function onAnswerScoreComplete(tw){
		card.updateScore(orderScore, answerScore, timeBonus);
		if(timeBonus == 0)onTimeBonusComplete();
		else{
		    star.alpha = 1;
		    star.x = 102, star.y = 77;
		    createjs.Tween.get(star).wait(0).to( {alpha:0, y:27 }, 500, createjs.Ease.linear ).call(onTimeBonusComplete)
		    createjs.Sound.play("keytap", {volume:0.02})
		}
		
	    }
	    function onTimeBonusComplete(tw){
		
		card.removeChild(star);
		star = null;
		
	    }
	    
	    scoreBox.updateScore();
	    
	    timeline.drawTimeline()
	    timeline.correctMarker.db = timeline.unmaskedContainer.getChildAt(timeline.unmaskedContainer.numChildren-1)//descBubble för nyss ditlagda event är sista child

	    //visa komplemet text
	    
	    card.allowAlternateQuestionComment();
	    card.alternateQuestionComment();
	      
	    //allow continue
	    stage.addEventListener('click', preRemoveCard);
	    timeline.addEventListener('clicknotdrag', removeCard);//custom event som skapas efter att koll av drag har gjorts inne
	    card.cursor = 'pointer';

	    
	    //använd tween som ren timer...
	    //createjs.Tween.get(proxyObj).to( {}, 6000 ).call(function(){scoreBox.clickInstructions.visible = true;});
	    //Använd setTimeout istället!
	    timeoutID = setTimeout( function(){scoreBox.clickInstructions.visible = true;}, 6000)
	   
	   // createjs.Tween.get(timeline.cursorMarker).to({alpha:0}, 1500);
	   // createjs.Tween.get(timeline.ind).to({alpha:0}, 1500);
	}
	
	function preRemoveCard(e){
	    //undantag om man klickar för att växla mellan frågetext/bild och kommentar
	    if(e.target == card.front)return
	    
	    //Vi måste kolla timeline separat så att drag inte resulterar i click
	    //Vi gör checken i timeline koden och stänger ned möjligheten för vanlig click här
	    if( checkForDisplayAncestor(e.target, timeline) == true)return //egenskriven rekursiv funktion finns i generalHelperFunctions
	    
	    removeCard(e);
	    
	}

        function removeCard(e){
	    
	    e.stopImmediatePropagation(); 
	    stage.removeEventListener('click', preRemoveCard);
	    timeline.removeEventListener('clicknotdrag', removeCard);

	    createjs.Tween.removeAllTweens();//hindrar att fortsatt poäng pch stjärn display sker på nytt kort (borde dock lösa på snyggare sätt)
	    clearTimeout(timeoutID);//OBS! detta gäller "click to continue" så texten ovan gäller ej
	    
	    scoreBox.clickInstructions.visible = false;
	    
	 
	    timeline.cursorMarker.visible = timeline.correctMarker.visible = false;
	    
	    timeline.ind.visible = false;
	    timeline.spanMarker.visible = false;
	    //timeline.removeClickedYearIndicator();
	    
	    
            //tween out old card
            createjs.Tween.get(card).to({x:game.canvasOrigWidth+card.w}, 1000, createjs.Ease.QuadOut);
	    
	    //check if: to continue, level completed, game over
	   
	    //if(orderScore == 0){
	    if(numErrors == 3){
		//stopLevel("WRONG ORDER");
		stopLevel("GAME OVER");
		createjs.Sound.play("gameover");
		
	    }
            else if(cards.length == 0){
		{

		    level++;
		    if(level > numLevels){
			stopLevel("GAME WON!")
			createjs.Sound.play("welldone");
		    }
		    else{
	
			stopLevel("WELL DONE!")
			createjs.Sound.play("welldone");
		    }
		}
	    }

            else{
                //pick a new card - i.e. a start a new inputchain
                inputChainGame();
            }          
        }
    }


    //denna är ej fristående utan använder globala score variabler
    function createScoreBox(){
	
	var that = new lib.ScoreBox;
	that.updateScore = updateScore;
	
	that.label1.cacheBounds();
	//that.label2.cacheBounds();
	//errors och checks har bitmapcachats via flash/toolkit
	
	that.check1.visible = that.check2.visible = that.check3.visible = false;
	
	that.clickInstructions.visible = false;
	
	
    
    
	//använd globala score variabler
	function updateScore(){
	    
	     that.totalScoreTF.text = ''+score;
	     that.totalScoreTF.cacheBounds();
	     
	    if(numErrors > 0)that.check1.visible = true;
	    if(numErrors > 1)that.check2.visible = true;
	    if(numErrors > 2)that.check3.visible = true;
	     
	     //that.levelScoreTF.text = ""+levelScore;
	     //that.levelScoreReqTF.text = "/"+reqLevelScore+"";
	     //
	     //if(levelScore < reqLevelScore)that.levelScoreTF.color = "#f44"
	     //else that.levelScoreTF.color = "#4f4"
	     
	//     var pointsLeft = reqLevelScore-levelScore;
	//     if (pointsLeft <= 0) {
	//	that.pointsLeftTF.visible = false;
	//	that.check.visible = true;
	//     }
	//     else{
	//	that.pointsLeftTF.visible = true;
	//	that.pointsLeftTF.text = ''+pointsLeft;
	//	that.pointsLeftTF.cacheBounds();
	//	that.check.visible = false;
	//     }
	}
	
	return that
    }

var aObj = {size:100};
}








