
function createBaloonHelp(tS/*textString*/, tFP/*textFieldProperties*/, bP/*baloonProperties*/, target/*baloon lggs som displaychild till targets parent*/
			  , globalX, globalY, addToStage){
	
	var c = new createjs.Container();

	if(tFP.font === undefined) tFP.font = "12px Arial, sans-serif";
	if(tFP.color === undefined) tFP.color = "#ffffff";
	if(tFP.lineWidth === undefined)tFP.lineWidth = 100;
	if(tFP.textAlign === undefined)tFP.textAlign = "left";

	c.tF = new createjs.Text(tS, tFP.font, tFP.color);
	c.tF.lineWidth = tFP.lineWidth;
	c.tF.textAlign = tFP.textAlign;
	
	var b = c.tF.rect = c.tF.getBounds();//ett center aligned tF har hlften av grafiken till vnster om sin reg. punkt, en right aligned har all grafik till vnster, o.s.v.
	
	if(bP.padding === undefined)bP.padding = 8;
	if(bP.strokeThickness === undefined)bP.strokeThickness = 3;//om stts till 0 kommer ingen stroke att ritas ut ven om createjs skulle ha ritat som hairline stroke
	if(bP.strokeColor === undefined)bP.strokeColor = "#ffffff"
	if(bP.fillColor === undefined)bP.fillColor = "#3399cc"
	if(bP.radius === undefined)bP.radius = 8;
	if(bP.arrowH === undefined)bP.arrowH = 0;//height
	if(bP.arrowDir === undefined)bP.arrowDir = "north";
	if(bP.shadow === undefined) bP.shadow = new createjs.Shadow("rgba(25,75,100,1)", 0/*x-off*/,0/*y-off*/, 5 /*blur*/);
	//de nedan anvnds ej nr "border" anvnds istllet fr egentlig stroke
	if(bP.strokeCaps === undefined)bP.strokeCaps = 'round';/*'butt'/0, 'round'/1, 'square'/2 */
	if(bP.strokeJoints === undefined)bP.strokeJoints = 'miter'; /*'miter'/0, 'round'/1, 'bevel'/2*/
	if(bP.strokeMiterLimit === undefined)bP.strokeMiterLimit = 10;//om fillspets r mindre n 10 grader dras inte strokespets till en kta spets (blir en beveled istllet)
	if(bP.strokeIgnoreScale === undefined) bP.strokeIgnoreScale = 'false';
	
	
	//OFFSET baseras p arrow spets position relativt origo fr tF & container
	var offsetX=0, offsetY=0;
	
	if(tFP.textAlign == "center"){
	    if(bP.arrowDir == "north"){ offsetX = 0;offsetY = -bP.padding-bP.arrowH;}
	    else if(bP.arrowDir == "east"){ offsetX = c.tF.rect.width/2+bP.padding+bP.arrowH; offsetY = c.tF.rect.height/2;}
	    else if(bP.arrowDir == "south"){ offsetX = 0 ;offsetY = c.tF.rect.height+bP.padding+bP.arrowH;}
	    else if(bP.arrowDir == "west"){ offsetX = -c.tF.rect.width/2-bP.padding-bP.arrowH; offsetY = c.tF.rect.height/2;}   
	}

	else if(tFP.textAlign == "left"){
	    if(bP.arrowDir == "north"){ offsetX = c.tF.rect.width/2; offsetY = -bP.padding-bP.arrowH;}
	    else if(bP.arrowDir == "east"){ offsetX = c.tF.rect.width+bP.padding+bP.arrowH; offsetY = c.tF.rect.height/2;}
	    else if(bP.arrowDir == "south"){ offsetX = c.tF.rect.width/2; offsetY = c.tF.rect.height+bP.padding+bP.arrowH;}
	    else if(bP.arrowDir == "west"){ offsetX = -bP.padding-bP.arrowH; offsetY = c.tF.rect.height/2;}   
	}
	//struntar i right align som knappast frekommer
	
	//ta reda p position fr ev. skickat target
	if(target !== undefined){

	    //stt localXY till pilspets position kring target
	    var localX, localY;
	    var tb = target.getBounds();
	    if(bP.arrowDir == "north"){ localX = tb.x + tb.width/2; localY = tb.y + tb.height;  }
	    else if(bP.arrowDir == "west"){ localX = tb.x + tb.width; localY = tb.y + tb.height/2; }
	    else if(bP.arrowDir == "south"){ localX = tb.x + tb.width/2; localY = tb.y ;}
	    else if(bP.arrowDir == "east"){localX = tb.x; localY = tb.y + tb.height/2;}
	    localX += target.x; localY += target.y;
	    
	    //ATT SKICKA TARGET MEDFR ATT CONTAINER INTE BARA RETURNERAS UTAN VEN LGGS TILL SAMMA KOORDINATSSYSTEM SOM TARGET MED OVAN FRAMTAGNA KOORDINATER

	     target.parent.addChild(c);
	     c.x = localX; c.y = localY;
	    
	    //stt global s att koll om overlap grs nedan

    	    var pt = target.parent.localToGlobal(localX, localY);
	    
	    globalX = pt.x;
	    globalY = pt.y;
	    
	    if(addToStage){
		target.parent.removeChild(c);
		stage.addChild(c)
		c.x = pt.x;c.y = pt.y;
	    }
	}
	
	//om x och y har angetts kan vi kolla om text kommer utanfr skrm och drefter justera offset 
	//verlapp i x-led?
	if(globalX !== undefined && (bP.arrowDir == "north" || bP.arrowDir == "south")){
	    var leftEdge = globalX + b.x - offsetX;
	    console.log("globalX", globalX, "b.x", b.x, "leftEdge", leftEdge);
	    var rightEdge = globalX + b.x + b.width - offsetX;
	    if(leftEdge < 0)offsetX += leftEdge;
	    if(rightEdge > game.canvasOrigWidth)offsetX += (rightEdge-game.canvasOrigWidth);
	}
	
	//verlapp i y-led?
	else if(globalY !== undefined && (bP.arrowDir == "west" || bP.arrowDir == "east")){
	    var topEdge = globalY + b.y - offsetY;
	    var bottomEdge = globalY + b.y + b.height - offsetY;
	    if(topEdge < 0)offsetY += topEdge;
	    if(bottomEdge > game.canvasOrigHeight)offsetY += (bottomEdge-game.canvasOrigHeight);
	}
	
	/*Skapa grafik*/
	//vi skapar drfr separata shapes fr fill och stroke eftersom de skapar varsin shadow i gemensam shape! Vi applicerar sedan endast shadow p shape fr fill
	
	//problem med stroke:
	//1.) draw round rect medfr ett streck som skiljer arrow frn baloon. Kan lsas genom att lgga stroke shape underst men d frsvinner halva thickenss. Alternativet r att gra round rect manuellt och skapa arrow inom denna ritning men det r omstndligt.
	//2.) eftersom separat skuggor mste vi allts ha tv shapes som bda mste skalas. Man kan lgga dem i en gemensam container, t.ex. bg, och skala den men d kommer inte skalningen att appliceras som mask p TF. Mask mste vara shape, ej container, och dess masks skalning utgr frn maskat objekts container.....
	//3.) stroke inkrktar p padding om ligger ovanp (ej ett problem om vi lgger den under, se 1.)
	//4.) shadow mste appliceras p fill men med stroke kommer skuggan att delvis dljas av stroke och skuggan kan aldrig motsvara egentliga dimensioner
	
	//drfr "border" gjort med fill istllet fr stroke.
	//Punkt 2 problemet terstr dock; ven om border och original fill lggs i samma shape kommer de att behandlas som tv separata objekt (de har ju olika frg) och f separata skuggor - drfr tv olika shapes
	
	//orignal fill rect
	var x = c.tF.rect.x-bP.padding;
	var y = c.tF.rect.y-bP.padding;
	var width = c.tF.rect.width + 2*bP.padding;
	var height = c.tF.rect.height + 2*bP.padding;
	
	//original arrow
	var p = [{},{},{}];
	var h = bP.arrowH;
	if(bP.arrowDir == "north"){
	    p[0].x = offsetX - h;	p[0].y = offsetY + h;		p[1].x = offsetX;	p[1].y = offsetY;	p[2].x = offsetX + h;	p[2].y = offsetY + h;}
	else if(bP.arrowDir == "east"){
	    p[0].x = offsetX - h;	p[0].y = offsetY - h;		p[1].x = offsetX;	p[1].y = offsetY;	p[2].x = offsetX - h;	p[2].y = offsetY + h;}
	else if(bP.arrowDir == "south"){
	    p[0].x = offsetX + h;	p[0].y = offsetY - h;		p[1].x = offsetX;	p[1].y = offsetY;	p[2].x = offsetX - h;	p[2].y = offsetY - h;}
	else if(bP.arrowDir == "west"){
	    p[0].x = offsetX + h;	p[0].y = offsetY + h;		p[1].x = offsetX;	p[1].y = offsetY;	p[2].x = offsetX + h;	p[2].y = offsetY - h;}
	
	//draw baloon
	c.baloonFill = new createjs.Shape();
	c.baloonFill.graphics.beginFill(bP.fillColor).drawRoundRect(x, y, width, height, bP.radius)
	if(bP.arrowH  > 0)c.baloonFill.graphics.mt(p[0].x, p[0].y).lt(p[1].x, p[1].y).lt(p[2].x, p[2].y).lt(p[0].x, p[0].y);
//	c.baloonFill.graphics.beginLinearGradientFill( ["#ffffff", "#cccccc"], [0,0.8], 0,0,0,b.height).drawRoundRect(b.x-marg,0,b.width+2*marg,b.height+3, radius)
	
	
	//border fill rect
	x -= bP.strokeThickness;
	y -= bP.strokeThickness;
	width += 2*bP.strokeThickness;
	height += 2*bP.strokeThickness;
	
	//border fill for arrow
	var t = 1.4*bP.strokeThickness;
	if(bP.arrowDir == "north"){ p[0].x -= t;	p[1].y -= t;	p[2].x += t;}
	else if(bP.arrowDir == "east"){ p[0].y -= t;	p[1].x += t;	p[2].y += t;}
	else if(bP.arrowDir == "south"){ p[0].x += t;	p[1].y += t;	p[2].x -= t;}
	else if(bP.arrowDir == "west"){ p[0].y += t;	p[1].x -= t;	p[2].y -= t;}
	
	//draw border	
	c.baloonBorder = new createjs.Shape();
	c.baloonBorder.graphics.beginFill(bP.strokeColor).drawRoundRect(x, y, width, height, bP.radius+bP.strokeThickness)
	if(bP.arrowH  > 0) c.baloonBorder.graphics.mt(p[0].x, p[0].y).lt(p[1].x, p[1].y).lt(p[2].x, p[2].y).lt(p[0].x, p[0].y)
	

	//STROKE
	//c.baloonStroke = new createjs.Shape();
	//if(bP.strokeThickness > 0)c.baloonStroke.graphics.setStrokeStyle(bP.strokeThickness, bP.strokeCaps, bP.strokeJoints, bP.strokeMiterLimit, bP.strokeIgnoreScale).beginStroke(bP.strokeColor).drawRoundRect(x, y, width, height, bP.radius)
	//
	//c.arrowStroke = new createjs.Shape();
	//h = bP.arrowH;
	//if(bP.strokeThickness > 0)c.arrowStroke.graphics.setStrokeStyle(bP.strokeThickness, bP.strokeCaps, bP.strokeJoints, bP.strokeMiterLimit, bP.strokeIgnoreScale).beginStroke(bP.strokeColor).mt(0,0).lt(h,h)
	//.mt(0,0)
	//.lt(-h,h);

	c.addChild(c.baloonFill);
	c.addChildAt(c.baloonBorder, 0);
	c.addChild(c.tF);

	//flytta alla displayobject s att de fr sitt ursprung fr skalning frn arrow spets
	c.tF.regX = c.baloonFill.regX = c.baloonBorder.regX = offsetX;
	c.tF.regY = c.baloonFill.regY = c.baloonBorder.regY = offsetY;

	//SHADOW: grundregel att nvnda crisp dropshadow om outline anvnds och blury glow (ingen offset) om outline ej anvnds
	//container kan inte ha en shadow i sig men om den stts fr alla dess childs, var fr sig, denna shadow. ven en shapes stroke och fill fr separata shadows!
	if(bP.strokeThickness > 0)c.baloonBorder.shadow = bP.shadow;
	else c.baloonFill.shadow = bP.shadow;
	
	c.tF.mask = c.baloonFill;//mask s att vi kan scala bara bg nr ballon ska visas

	c.scaleUp = function (time, scaleAll){
	    
	    if(time == undefined)time = 2000;
	    c.visible = true;
	    
	    //skala upp allting
	    if(scaleAll == undefined){
		
		c.scaleX = c.scaleY = 0;
		createjs.Tween.get(c).to({scaleX:1, scaleY:1}, time, createjs.Ease.QuadOut)

	    }
	    //annars skalar vi bara baloon s medan content fbli oskalat men maskas av baloon och, fr extra mjukt intryck, ven fadar
	    else{
		c.tF.alpha = 0;
		c.baloonFill.scaleX = c.baloonFill.scaleY = c.baloonBorder.scaleX = c.baloonBorder.scaleY = 0.0;
		createjs.Tween.get(c.tF).to({alpha:1}, time, createjs.Ease.QuadOut)
		.addEventListener("change", handleChange);
		function handleChange(e){
		    c.baloonFill.scaleX = c.baloonFill.scaleY = c.baloonBorder.scaleX = c.baloonBorder.scaleY = c.tF.alpha;
		}
	    }
	}
    return c;
}
