/*--------------------------
 general helper functions
--------------------------*/

function submitScore(){
    console.log("submitScore");
}

function checkForDisplayAncestor(child, ancestor){
    //if(child == ancestor)return true;
    //else
    if(child.parent == ancestor)return true;
    else if(child.parent == stage)return false;
    else return checkForDisplayAncestor(child.parent, ancestor);
    
}
   
//fr textfield med bestmd width och bestmd height    
function adjustTextSize3(tF, tFP/*textFieldProperties - utver createjs tF properties ingr maxHeight & lineHeightFactor*/){

    //Explicit satta tFP properties har fretrde framfr redan befintliga tF properties
    
    //tF.lineWidth r satt i flash och avgr nr radbrytning sker. om satt till 0/null (i flash via cirkel istllet fr kvadrat) anpassas width efter textlng
    if(tFP.lineWidth === undefined){
	if(tF.lineWidth === 0)tF.lineWidth = 100;//vi anvnder allts 100 som default linewidth om den ej har satts i tF eller skickats med tFP
    }
    else tF.lineWidth = tFP.lineWidth;
   
    if(tFP.textAlign !== undefined)tF.textAlign = tFP.textAlign;
    
    if(tFP.maxHeight === undefined)tFP.maxHeight = 100;
    
    //flash skapat tF har fast lineHeight som ej ndras nr fontstorlek ndras
    //om vi skickar med lineHeightFactor stts lineheight till fontsize*lineheightfactor
    //om inte, stter vi lineheight till 0/null s att getMeasuredLineHeight() istllet anvnds och justeras efter fontsize
    if(tFP.lineHeightFactor === undefined)tF.lineHeight = 0;
    else tF.lineHeight = tFP.fontSize*tFP.lineHeightFactor;
    //skulle vara bra om vi slapp ange font och kunde anvnda redan satt font (om sdan finns)
    //men eftersom vi ska ndra del av fontstrngen (fontSize) skulle vi d vara tvungna att 'parsa' strngen
    //fr att undvika det mste alltid fontstrngens olika bestndsdelar anges - i annat anvnds default vrden
    
    //tF.font = //set like CSS composite font property, i.e., "normal/italic normal/small-caps normal/bold 16px arial, sans-serif". Only size & font-family is required
    if(tFP.fontFamily === undefined)tFP.fontFamily = "arial, sans-serif";
    if(tFP.fontStyle === undefined)tFP.fontStyle = "normal";
    if(tFP.fontWeight === undefined)tFP.fontWeight = "normal";
    tF.font = tFP.fontStyle + " " + tFP.fontWeight + " " + tFP.fontSize + "px " + tFP.fontFamily;
    
    var h = tF.getBounds().height;
    //getBounds anvnder tF.lineHeight om det inte r 0 och annars tF.getMeasuredLineHeight() och multiplcerar med antal rader (som kan fs frn tF.getMetrics().lines.length)
    while(h > tFP.maxHeight){
        tFP.fontSize -= 1
        if(tFP.lineHeightFactor !== undefined)tF.lineHeight = tFP.fontSize*tFP.lineHeightFactor;
	tF.font  = tFP.fontStyle + " " + tFP.fontWeight + " " + tFP.fontSize + "px " + tFP.fontFamily;
	h = tF.getBounds().height;
    }
    
    //center aligned text ska vem centreras vertikalt i maxHeight rektangeln
    if(tF.textAlign == "center"){
	//horisontellt
	tF.x = 0;
	//vertiklat
	tF.y += (tFP.maxHeight-h)/2
    }
    
    tF.h = h; tF.fS = tFP.fontSize;
    return h//fontSize 
}


function numberToReadableString(number, twoLines, scaleToAdjustTo) {
    
    number = Math.round(number);
    if (scaleToAdjustTo ) {
	    var yearsPerPixel = 1/scaleToAdjustTo;
	    //obs avrudningsfel gr att exp fr 1000 inte blir 3 utan typ 2.999996. finns ny log10 funktion som lser detta men stds  ej verallt
	    //pga anvnds Math.round istllet fr Math.floor som frst var tnkt (skulle sklar ocks kunna lsas genom att addera ett litet tal)
	    var exp = Math.round( Math.log(yearsPerPixel)/Math.LN10 );
	    yearsPerPixel = Math.pow(10, exp);//nu har vi det uttryckt i jmnt 10-potens tal som 100, 1000...
	    
	    //ta nu bort ondiga/verprecisa siffor frn number
	    number = Math.round(number/yearsPerPixel)*yearsPerPixel;
    }
     
    //omvandla tal till array av siffror/chars (autoomvandling i js)
    //alterantiv r algoritm med /(10 potens) och %. Testa vad som r snabbast?
    var s = ""+number;
    var a = s.split("");
    
    var pow = a.length;
    if (number<0)pow -=1;//minustecknet ska inte rknas
    
    var new_a;
    var numEndZeros = 0;
    /*sra siffertrios*/ 
    if ( pow >= 5){//sra fr 10 000 men ej fr 9999	
	a.reverse();
	
	var i=0;
	
	while(a[i] === '0'){
	    numEndZeros++;//to use if "bill.", "mill.", "thous." should be used instead of ending zeros
	    i++
	}
	
	if (number<0)a.pop();//ta bort minustecken
	
	new_a = [];
	off = 0;
	
	var l = a.length;
	for (i=0; i<l; i++) {
	    
	    if (i%3==0) {
		if (i==6 && twoLines==true) {
		    new_a.push("\n");
		}
		else new_a.push(" ");
		off++;
	    }
	    new_a[i+off] = a[i];
	}
	if (twoLines) {
	    
	    //eftersom antalet heltals miljarder r s f ska de kunna anges som t.ex 13.8 bil. medan miljoner bara anges med heltal
	    
	    if (number <= -1000000000) {
		return( number/1000000000 + " \nbil.");
	    }
	//    else
	//    if (numEndZeros >= 9) {
	//	return( number/1000000000 + " \nbil.");
	//    }
	    else if (numEndZeros >= 6) {
		return( number/1000000 + " \nmil.");
	    }
	}
	if (number<0)new_a.push('-');//lgg tillbaka minustecken
	new_a.reverse();
	s = new_a.join("");
    }
    return(s);
}

//viktigt att denna verkligen ger motsvarande vrden som spegelfunktion dateToYear nedan
function yearToDate(yr, day){ //yr innehller tillrcklig information men om inte day r explicit satt vill vi inte skriva ut dag utan endast mnad
    months = ["Jan.", "Feb.", "March", "April", "May", "June", "July", "Aug.", "Sep.", "Oct.", "Nov.", "Dec." ]
    
    y = Math.floor(yr);
    var days = Math.round(365*(yr-y));
    
   daysInMonths = [31,28,31,30,31,30,31,31,30,31,30,31];//bryr oss om ej skottr
    
    var i=0; 
    while(days > daysInMonths[i]){
	days -= daysInMonths[i]
	i++;
    }
    if(days === 0)days = 1;//annars blir ett jmnt yr, t.ex. 1980, "0 jan 1980";
    
    if( day === undefined)return(months[i] + "\n" + y);
    else return(days + " " + months[i] + "\n" + y);
    
}
function dateToYear(y,m,d){
    
    daysInMonths = [31,28,31,30,31,30,31,31,30,31,30,31];//bryr oss om ej skottr
    //vi frutstter att m alltid skickas men inte alltid d
    if(d === undefined) d=Math.floor(daysInMonths[m]/2);
    var days = d
    for (var i=0; i<m-1; i++) {
	days += daysInMonths[i]
    }
    
    return y+days/365;   
}

function linearFunction(x1,x2,y1,y2,x,y) {

     if(x === undefined){
	x = x1+(y-y1)*(x2-x1)/(y2-y1);
	return x
    }
    else if(y === undefined){
	y = y1+(x-x1)*(y2-y1)/(x2-x1);
	return y
    }
}
//draws chequered bg
function drawBg(bg/*createjs.Shape*/, w, h, numCols,  zoom/*0.0-1.0*/){
	
	
	bg.graphics.beginFill("#cacaff");
	var size = Math.ceil(w/numCols );
	bg.graphics.drawRect(0,0,w+2*size,h+2*size);
	numCols = Math.ceil(w/size) + 2;//+2 fr scrollning
	var numRows = Math.ceil(h/size);
	
	var la = 0.5
	var ra = 0.8
	var ea = 0.1
	var dla = (ea-la)/(numRows-1);
	var dra = (ea-ra)/(numRows-1);
	var a = 1
	for(var r=0;r<numRows;r++){
		for(var c=0;c<numCols;c++){
			if((r%2 == 0 && c%2 == 0) || (r%2 != 0 && c%2 != 0)){
				a = la + r*dla 
			}
			else a = ra +r*dra;
			
			bg.graphics.beginFill("rgba(0,0,0," + a + ")")
			bg.graphics.drawRect(c*size,r*size,size,size)
		}
	}
	
	bg.cache(0,0,w+2*size,h+2*size);
	
	bg.panVal = 0;
	bg.zoomVal = 0;
	
	bg.scroll = function (dPan, absPan/*0.0-1.0*/, dScale){
	    
	    bg.panVal -= dPan;
	    bg.panVal += dScale;
	    if(absPan != undefined)bg.panVal = absPan;
	    
	    if(bg.panVal > 1) bg.panVal = (bg.panVal%1);
	    else if(bg.panVal < 0) bg.panVal = 1+(bg.panVal%1);
	    bg.x = -size*2*bg.panVal;
	}
}

//function conformData(name_for_q, name_for_c, name_for_a, name_for_d, name_for_df, name_for_series, name_for_pic, name_for_circa, name_for_p, name_for_minScale ){

function conformData(names){
    
    //om vi inte skickat med ett namn frutstts att vi redan anvnder det namn som koden i vrigt anvnder sig av!
    //Det innebr att om man anvnder ngot av dessa default names fr annan property mste man skicka med annat namn fr den property som normalt anvnder default name
    if(names.for_question == undefined)names.for_question = "q";
    if(names.for_comment == undefined)names.for_comment = "c";
    if(names.for_answeryear == undefined)names.for_answeryear = "a";
    if(names.for_description == undefined)names.for_description = "d";
    if(names.for_series == undefined)names.for_series = "series";
    if(names.for_pic == undefined)names.for_pic = "pic";
    if(names.for_isCirca == undefined)names.for_isCirca = "isCirca";
    if(names.for_precision == undefined)names.for_precision = "p";
    if(names.for_minscale == undefined)names.for_minscale = "minScale";
    if(names.for_difficulty == undefined)names.for_difficulty = "df";
    //obs att vi ocks kan ha skicakt med name.for_month och name.for_day
    //de fanvnds inte i koden i vrigt utan hanteras endast nedan (om de har skickats)
    if(names.for_month == undefined)names.for_month = "month";
    if(names.for_day == undefined)names.for_day = "day";
    
       
    //kopiera gameData.questions
    var temp = [];
    for(var i=0, l=gameData.questions.length;i<l;i++){
        temp[i] = gameData.questions[i];
    }
    
    //skapa ny gameData.questions och fyll den med originaldata men nu i properties med rtt namn
    //om ingen orignaldata finns ges ett defaultvrde
    for(var i=0, l=temp.length;i<l;i++){
       
        gameData.questions[i] = {};//skapa nytt objekt s gamla properties ej finns kvar
	
	gameData.questions[i].orig_i = i;
        
	gameData.questions[i].q = temp[i][ names.for_question ];
        if(gameData.questions[i].q == undefined)gameData.questions[i].q = "";//milestones har ingen defined q och ges ""
	
        gameData.questions[i].c = temp[i][ names.for_comment ];
        if(gameData.questions[i].c == undefined)gameData.questions[i].c = "";
	
	gameData.questions[i].a = temp[i][ names.for_answeryear ];
	if(gameData.questions[i].a == Math.floor(gameData.questions[i].a)){
	    gameData.questions[i].a += 0.5;//if month and date is not given
	    gameData.questions[i].isIntYear = true;
	}
	else gameData.questions[i].isIntYear = false;
	//kolla nu om vi skickat med month och eller day och justera isfall year
	if(temp[i][names.for_month] != undefined){
	    console.log("month defined")
	    gameData.questions[i].isIntYear = false;
	    gameData.questions[i].a = dateToYear(temp[i][ names.for_answeryear ] , temp[i][ names.for_month ], temp[i][ names.for_day ]);
	}
	gameData.questions[i].month = temp[i][ names.for_month ];
	gameData.questions[i].day = temp[i][ names.for_day ];

        gameData.questions[i].d = temp[i][names.for_description];
        if(gameData.questions[i].d == undefined)gameData.questions[i].d = temp[i][ names.for_question ];
        
	//difficulty anvnds fortfarande men endast fr att knna igen milestones
        gameData.questions[i].df = temp[i][ names.for_difficulty ];
    
        gameData.questions[i].series = temp[i][ names.for_series ];
	if(gameData.questions[i].series == undefined)gameData.questions[i].series = [];
        //lgg till en allmn serie om frga finns (allts inte tjnar endast som label)
	if(gameData.questions[i].q != "")gameData.questions[i].series.push(0);//alla egentliga frgor frs allts till serie 0
        
        gameData.questions[i].pic = temp[i][ names.for_pic ];
        
	
        gameData.questions[i].isCirca = temp[i][ names.for_isCirca ];
        
        gameData.questions[i].p = temp[i][ names.for_precision ];;
        if(gameData.questions[i].p == undefined)gameData.questions[i].p = 0;
	
	gameData.questions[i].minScale = temp[i][ names.for_minScale ];
	if(gameData.questions[i].minScale == undefined)gameData.questions[i].minScale = 0.01;//innebr att labels & baloons ska visas i alla lgen. Om minScale t.ex. r 10 ska de visas endast nr skalan r 10 pixels/r eller strre

    }
    temp = null;
}
   
function getDimensions(){
    
    var s = "";
    s += "document.documentElement.clientWidth: " + document.documentElement.clientWidth;
    s += "\ndocument.documentElement.clientHeight: " + document.documentElement.clientHeight;
    s += "\ndocument.documentElement.offsetWidth: " + document.documentElement.offsetWidth;
    s += "\ndocument.documentElement.offsetHeight: " + document.documentElement.offsetHeight;
    s += "\ndocument.documentElement.scrollWidth: " + document.documentElement.scrollWidth;
    s += "\ndocument.documentElement.scrollHeight: " + document.documentElement.scrollHeight;
    s += "\n";
    s += "\ndocument.body.clientWidth: " + document.body.clientWidth;
    s += "\ndocument.body.clientHeight: " + document.body.clientHeight;
    s += "\ndocument.body.offsetWidth: " + document.body.offsetWidth;
    s += "\ndocument.body.offsetHeight: " + document.body.offsetHeight;
    s += "\ndocument.body.scrollWidth: " + document.body.scrollWidth;
    s += "\ndocument.body.scrollHeight: " + document.body.scrollHeight;
    s += "\n";
    s += "\ncanvas.clientWidth: " + canvas.clientWidth;
    s += "\ncanvas.clientHeight: " + canvas.clientHeight;
    s += "\ncanvas.offsetWidth: " + canvas.offsetWidth;
    s += "\ncanvas.offsetHeight: " + canvas.offsetHeight;
    s += "\ncanvas.scrollWidth: " + canvas.scrollWidth;
    s += "\ncanvas.scrollHeight: " + canvas.scrollHeight;
    s += "\n";
    s += "\nwindow.innerWidth: " + innerWidth;
    s += "\nwindow.innerHeight: " + innerHeight;
    s += "\n";
    s += "\nscreen.width: " + screen.width;
    s += "\nscreen.height: " + screen.height;
    s += "\n";
    s += "\nscreen.availWidth: " + screen.availWidth;
    s += "\nscreen.availHeight: " + screen.availHeight;

    
    return s;
}
//CSS styr vad som rknas som small screen/mobile och vilken orientation. CSS anpassas hela tiden efter ndrade frhllanden. Javascript funkar inte eftersom browsers tolkning varierar mycket.
//websidan ska visas likadant med tv undantag: (1) liten skrm i portrait mode ska visa meddelande om att landscape mode ska anvndas, (2) liten skrm i landscape mode ska endast visa canvas - allt annat ges display: none.

function isScreenSmall()
{
    //OR returnerar den frsta operanden om den r truthy annars returneras den andra
    //p dettta stt funkar det oavsett om vi kr spelet i separat html som visas via iframe eller om spelet r en del av html fr hela websidan    
    var e = document.getElementById("vertMenu") || top.document.getElementById("vertMenu");
    
    //vanliga element.style har bara vrden som r satta med javascript
    //IE8 eller lgre anvnder currentStyle, vriga getComputedsStyle()
    var s = e.currentStyle ? e.currentStyle.display : getComputedStyle(e, null).display;

    if(s == "none")return true;
    else return false;
}
function isScreenSmallLandscape()
{
    if(isScreenSmall() == false)return false;
    
    var e = document.getElementById("msg") || top.document.getElementById("msg");
    //vanliga element.style har bara vrden som r satta med javascript
    //IE8 eller lgre anvnder currentStyle, vriga getComputedsStyle()
    var s = e.currentStyle ? e.currentStyle.display : getComputedStyle(e, null).display;
    
    if(s == "block")return false;
    else return true;;   
    
}

//iom ny css avkopplades onWindowResize i game.js
function onWindowResize(e){//aktiveras endast om krd html-fil har ett element med id="vertMenu" 
    
    
    //alert("resize " + getDimensions());
    //fortstt bara om vi r i landscape. notera att resize kan ha triggats av byte frn portrait till landscape
    if(isScreenSmallLandscape()){
	//nu vet vi att canvas r enda synligt element i browser fnster

	/*FULLSCREEN MSTE AKTIVERAS I MOUSEEVENT HANDLER ELLER KEYPRESS HANDLER*/
	//frsk ge canvas ensmartt till skrm (=fullscreen)
	//om fullscreenlge aktiveras triggas en resize igen men koll hr hindrar ett ondigt aktiveringsfrsk
	//if(game.canvasIsFullScreen == false) requestFullscreenCanvas();
	
	//maxa canvas storlek till fnster (eller skrm om fullscreen r aktiverat)
	scaleCanvasMax(false);
	top.scrollTo(0,1);
	console.log("SCROLL 0, 1")
	
	//if(game.canvasIsFullScreen == false){
	//    //ndra touch s att allowDefault = true (scroll/zoom av documenent kan gras p canvas )
	//    createjs.Touch.enable(stage, /*singleTouch=*/ true, /*allowDefault=*/ true);
	//    game.defaultTouchIsAllowed = true;
	//}
	
    }
    //Nedanstende tycker jag borde tckas av css och inte behvas men s r inte fallet (som om js ndringar pverkar priorierade alias till css vrden och bara kan terstllas via js)
    //Om terstllning av storlekar inte sker kan canvas bli fr stor nr tergng till vanlig layout sker
    //och canvas hamnar d under navbar och reklamcontainer
    else{
	
	//container har ersatts av fixedWidthDiv i ny css
	var e = document.getElementById("container") || top.document.getElementById("container");
	e.style.width = "1280px";
	
	//gameContainer har ersatts av midColumn i ny css
	e = document.getElementById("gameContainer") || top.document.getElementById("gameContainer");
	
	e.style.width = canvas.style.width = "800px";
	canvas.style.height = "450px";
	
	var iFr = top.document.getElementById("gameFrame");
	if(iFr != null){
	    iFr.width = iFr.style.width = "800px";
	    iFr.height = iFr.style.height = "450px";
	
	}
	console.log("SCROLL 0, 0")
	top.scrollTo(0,0)
	
	//if(game.canvasIsFullScreen == true)cancelFullscreenCanvas();
	//createjs.Touch.enable(stage, /*singleTouch=*/ true, /*allowDefault=*/ false);
	//game.defaultTouchIsAllowed = false;
	
    }
}

//will scale canvas to max without any part outside of window
function scaleCanvasMax(scaleStage/*if true, stage will scale instead of canvas-element, this will improve vector art resolution*/) {
    
    var winW, winH;
    
    //IE does not support innerWidth 
    if (top.innerWidth == undefined)winW = top.document.documentElement.clientWidth;//normalt sett anvnds documentElement men fr IE ska body anvndas?
    else{
	winW = top.innerWidth;
	console.log("winW", winW)
    }
    if (top.innerHeight == undefined)winH = top.document.documentElement.clientHeight;
    else{
	winH = top.innerHeight;
	console.log("WinH", winH)
    }
    
    
    var maxH, maxW;
    //maxa inte bda utan gr det med bibehllna proportioner
    if(winW/game.canvasOrigWidth > winH/game.canvasOrigHeight){
	maxH = winH;
	maxW = game.canvasOrigWidth*maxH/game.canvasOrigHeight;
    }
    else{
	maxW = winW;
	maxH = game.canvasOrigHeight*maxW/game.canvasOrigWidth;
    }
    console.log("maxW", maxW)
    console.log("maxH", maxH)
    
    if (scaleStage == true) {
	canvas.width = maxW;
	canvas.height = maxH;
	stage.scaleX = stage.scaleY = canvas.width/game.canvasOrigWidth;
    }
    else
    {
	
	//document.getElementById("container").style.width = document.getElementById("gameContainer").style.width = canvas.style.width = maxW + "px";
	//document.getElementById("container").style.height = document.getElementById("gameContainer").style.height = canvas.style.height = maxH + "px";
	
	var e = document.getElementById("container") || top.document.getElementById("container");
	e.style.width = maxW + "px";
	
	e = document.getElementById("gameContainer") || top.document.getElementById("gameContainer");
	
	e.style.width = canvas.style.width = maxW + "px";
	canvas.style.height = maxH + "px";
	
	var iFr = top.document.getElementById("gameFrame");
	if(iFr != null){
	    iFr.width = iFr.style.width = maxW + "px";
	    iFr.height = iFr.style.height = maxH + "px";
	}
    }
}

function requestFullscreenCanvas(e){//show only canvas on hardware screen (i.e., black borders + canvas)
    
    //window.scrollTo(0,1)//works only if there is element below canvas to scroll to. Hides address bar and disables user scrolling on mobile
 
    //till canvas fullskrms lge: inre fnster = skrm & canvas enda synliga element. Men ingen skalning av canvas.
    //window.resize event triggas och frst dr frstoras canvas
    
    //Obs! nedanstende funkar bara i en eventhandler!
    if(canvas.webkitRequestFullScreen) {
	
        canvas.webkitRequestFullScreen(canvas.ALLOW_KEYBOARD_INPUT);
    }
    else if(canvas.mozRequestFullScreen) {
   
	canvas.mozRequestFullScreen();
    }
    else if(canvas.msRequestFullScreen) {
	
        canvas.msRequestFullScreen();
    }
    else if(canvas.requestFullscreen) {
       
	canvas.requestFullscreen();
    }
    //kolla om vi lyckades och isfall stt game.canvasIsFullScreen
    if(document.fullscreenElement == canvas || document.mozFullScreenElement == canvas || document.webkitFullscreenElement == canvas || document.msFullscreenElement == canvas) {
	game.canvasIsFullScreen = true;
	
    }
    else game.canvasIsFullScreen = false;
    
    return;
    
}
function cancelFullscreenCanvas(e){
//    if(!document.fullscreenElement && !document.mozFullScreenElement && !document.webkitFullscreenElement && !document.msFullscreenElement) {
//	return;
//    }
    //hitta rtt funktion
    var cancelFullscreen = document.exitFullscreen || document.mozCancelFullScreen || document.webkitExitFullscreen || document.msExitFullscreen;
    //syntax r t.ex. document.webkitExitFullscreen() men eftersom vi isolerat funktionen i en variabel mste vi anvnda call(document) s att this blir document
    cancelFullscreen.call(document);
    
    //kolla om vi lyckades och isfall stt game.canvasIsFullScreen
    if(document.fullscreenElement == canvas || document.mozFullScreenElement == canvas || document.webkitFullscreenElement == canvas || document.msFullscreenElement == canvas) {
	game.canvasIsFullScreen = true;
    }
    else game.canvasIsFullScreen = false;
    
    return;
}



/*----------------------------
            TEST
-----------------------------*/
 function testPrototypeConcept(){   
    var I = new MyObj(44);
    console.log(I.age);
    
    //THE OUTPUT OF getPrototypeOf and .prototype IS VERY CONFUSING. WE DO NOT GET THE ACTUAL OBJECT.
    console.log(Object.getPrototypeOf(I)); // -> MyObj{} //In a sense this is like asking: what is I an instance of?
    console.log(MyObj.prototype);// -> MyObj{} //But the .prototype is actually an instance of Object, see below!
    
    console.log(I instanceof MyObj);//-> true //
    console.log(MyObj.prototype instanceof Object);//-> true
    console.log(I instanceof Object);//-> true   .instanceof anvnds fr att kolla om instansen har typen i sin prototypekedja - funkar allts bara nr new anvnds
    console.log(MyObj.prototype instanceof MyObj);//-> false //ANGES SOM MyObj{} MEN RKNAS INTE SOM INSTANS AV MyObj...
    console.log(typeof(I));//-> object //.typeof returnerar string och anvnds fr att skilja p primitiva types & object & function.  
    console.log(typeof(MyObj.prototype));//-> object
    console.log(typeof(MyObj.prototype));//-> object
    
    //The prototype of instance I and the property .prototype both refers to an object...
    //...that is DEFINED by MyObj but it is NOT EQUAL to MyObj and it is NOT an instance of MyObj!
    //It is also not at all the same as the actual prototype of MyObj, which instead is defined by the Function object
    //(The 'define' aspect is indicated by the curly brackets in the console.log output)
    
    
    MyObj.prototype.increaseAge = function(incr){//this will not be used as it is one step further back in the chain and is therefore overridden by the this.increaseAge
	console.log("prototypem method")
	this.age += incr
    }
   // MyObj.prototype.size = 100;
    MyObj.prototype = {};//volume:300};//nu har vi frikopplat .prototype frn Object.getPrototypeOf(I)! ndringar i prototype kommer ej att berra I
    console.log("{}?", MyObj.prototype);
    console.log("size", I.size);
    MyObj.prototype.size = 200;
    console.log("size", I.size);
    I.increaseAge(30);
    console.log(I.age);
    I.increaseAge(50);
    console.log(I.age);
    MyObj.prototype.decreaseAge = function(decr){
	this.age -= decr;
	if (this.age < 0)this.age = 0;
    }
   // I.decreaseAge(50);
    console.log(I.age)
    console.log(I, MyObj.prototype);
    var K = new MyObj(200);
    console.log(K)//K kommer inte att ha samma prototype object som I
 }
 function MyObj(age) {
    
  
    var maxAge = 100;//'private' variable. Each instance will have it's own copy as it is included in a this. attached function
    //1. When a function (any function) is defined an empty object is created and said to be of a type that has the same name as the function. (This is true even for the basic Object type which gets its name from the Object function)
    //2. The Function object itself has property .prototype that refers to this empty object
    //!!!Note the conflicting output console.log of the .prototype object itself and with the instanceof operator and typeof() function!!!
    
    //When the new operator is used (i.e. instantiation)
    //3. Create another empty object and say that this is an instance of the function type and that the .prototype is the "prototype" for this object (they share properties but the new instance can have properties that override these)
    //4. Let the keyword this inside the function refer to the new object and give it properties/methods
    this.age = age;
    this.increaseAge = function(incr) {
	console.log("method to instances of new created")
	this.age += incr;
	if (this.age > maxAge)this.age = maxAge;
    }  
    //5. return this
}

//summary
//Functions are special type of objects that can be used to create new objects.
//a function with the name Animal can for example be used to create the object animal by writing aBeast = new Animal. the object aBeast is now said to be "an object/instance of the type Animal" 
//Functions are themselves objects/instances of the type Function, which is the original function object that the compiler/interpreter has special rules for)
//Every object has a prototype object to hold properties/methods shared for all objects of the same function/type. This prototype object is naturally stored as a property of the function/type object!
//Note that it is possible to exchange this object by referring .prototype to a custom created object.This is of course not recommended!
